﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var BankGuaranteesTable = (function (_super) {
    __extends(BankGuaranteesTable, _super);
    function BankGuaranteesTable(document) {
        var _this = _super.call(this, "BankGuarantees", document) || this;
        _this._docs = null;
        _this._protocolEmployee = null;
        _this._providerNode = null;
        _this._rate = new NumberObasTableField("Rate", _this);
        _this._rubValue = new NumberObasTableField("RubValue", _this);
        _this._entryDate = new ObasTableField("EntryDate", _this);
        _this._entryCondition = new ObasTableField("EntryCondition", _this);
        _this._expiryDate = new ObasTableField("ExpiryDate", _this);
        _this._expiryCondition = new ObasTableField("ExpiryCondition", _this);
        _this._regDate = new ObasTableField("RegDate", _this);
        _this._bankPost = new ObasTableField("BankPost", _this);
        _this._bankFullName = new ObasTableField("BankFullName", _this);
        _this._infoSheetsCount = new NumberObasTableField("InfoSheetsCount", _this);
        _this._docSheetsCount = new NumberObasTableField("DocSheetsCount", _this);
        _this._isPortable = new ObasTableField("IsPortable", _this);
        _this._protocolDate = new ObasTableField("ProtocolDate", _this);
        _this._protocolNum = new ObasTableField("ProtocolNum", _this);
        _this._ownerKey = new NumberObasTableField("Owner_ID", _this);
        _this._ownerRegCode = new ObasTableField("Owner_RegCode", _this);
        _this._ownerRegDate = new ObasTableField("Owner_RegDate", _this);
        return _this;
    }
    Object.defineProperty(BankGuaranteesTable.prototype, "OrgProvider", {
        get: function () {
            var providerTable;
            var providerKey = -1;
            switch (this.ProviderType) {
                case ProviderTypes.LegalEntity:
                    providerTable = TableCollection.LegalEntityProviderTable;
                    providerKey = this.LegalEntityProvider.Value;
                    break;
                case ProviderTypes.ForeignLegalEntity:
                    providerTable = TableCollection.ForeignLegalEntityProviderTable;
                    providerKey = this.ForeignLegalProvider.Value;
                    break;
            }
            if (providerTable != null && providerTable.LocateByKeys(providerKey)) {
                return providerTable;
            }
            else {
                return null;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "ForeignProvider", {
        get: function () {
            var providerTable;
            var providerKey = -1;
            switch (this.ProviderType) {
                case ProviderTypes.ForeignCitizen:
                    providerTable = TableCollection.ForeignCitizenTable;
                    providerKey = this.ForeignCitizenProvider.Value;
                    break;
                case ProviderTypes.ForeignLegalEntity:
                    providerTable = TableCollection.ForeignLegalEntityProviderTable;
                    providerKey = this.ForeignLegalProvider.Value;
                    break;
            }
            if (providerTable != null && providerTable.LocateByKeys(providerKey)) {
                return providerTable;
            }
            else {
                return null;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "Status", {
        get: function () {
            return (this.StatusField.ForeignKey.Value || DataStatuses.Draft);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "Docs", {
        get: function () {
            if (this._docs == null) {
                this._docs = new BankGuaranteesDocsTable(this);
            }
            return this._docs;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "Rate", {
        get: function () {
            return this._rate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "RegistryDate", {
        get: function () {
            return this._regDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "RubValue", {
        get: function () {
            return this._rubValue;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "SheetsCount", {
        get: function () {
            return this._infoSheetsCount;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "DocumentsSheetsCount", {
        get: function () {
            return this._docSheetsCount;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "IsPortable", {
        get: function () {
            return this._isPortable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "ProtocolNum", {
        get: function () {
            return this._protocolNum;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "ProtocolDate", {
        get: function () {
            return this._protocolDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "BankPost", {
        get: function () {
            return this._bankPost;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "BankFullName", {
        get: function () {
            return this._bankFullName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "FullEntryInfo", {
        get: function () {
            var result = ObasHelper.ConvertToString(this._entryDate.Value);
            if (this._entryCondition.Value) {
                result += " (" + this._entryCondition.Value + ")";
            }
            return result;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "FullExpiryInfo", {
        get: function () {
            var result = ObasHelper.ConvertToString(this._expiryDate.Value);
            if (this._expiryCondition.Value) {
                result += " (" + this._expiryCondition.Value + ")";
            }
            return result;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "ProtocolEmployee", {
        get: function () {
            if (this._protocolEmployee == null) {
                this._protocolEmployee = new EmployeeFields(this, "Protocol");
            }
            return this._protocolEmployee;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "OwnerRegistryCode", {
        get: function () {
            return this._ownerRegCode;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "OwnerRegistryDate", {
        get: function () {
            return this._ownerRegDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesTable.prototype, "LastStatusEmployee", {
        get: function () {
            switch (this.Status) {
                case DataStatuses.Included:
                    return this.StatementEmployee;
                case DataStatuses.Denied:
                    return this.ProtocolEmployee;
                default:
                    return null;
            }
        },
        enumerable: true,
        configurable: true
    });
    BankGuaranteesTable.prototype.InitLegalEntity = function () {
        return new ProviderKeyTableField(TableCollection.LegalEntityProviderTable, this, "LegalEntityProvider");
    };
    BankGuaranteesTable.prototype.InitIndividual = function () {
        return new ProviderKeyTableField(TableCollection.IndividualBusinessmanTable, this, "IndividualBusinessmanProvider");
    };
    BankGuaranteesTable.prototype.InitForeignCitizeny = function () {
        return new ProviderKeyTableField(TableCollection.ForeignCitizenTable, this, "ForeignCitizenProvider");
    };
    BankGuaranteesTable.prototype.InitForeignLegal = function () {
        return new ProviderKeyTableField(TableCollection.ForeignLegalEntityProviderTable, this, "ForeignLegalEntityProvider");
    };
    BankGuaranteesTable.prototype.InitCustomer = function () {
        return new VersionElementForeignKeyTableField(TableCollection.CustomerTable, this, "CustomerDetails");
    };
    BankGuaranteesTable.prototype.InitStatusField = function () {
        return new ObasSprTableField(TableCollection.DataStatusesSprTable, this);
    };
    BankGuaranteesTable.prototype.GetXlsTemplate = function () {
        return BankGuaranteesTable._xlsTemplate;
    };
    BankGuaranteesTable.prototype.DoAfterCopy = function (sourceKey) {
        this.Docs.CopyDocuments(sourceKey, this.RecordKey.Value);
        this.TofkKey.Value = null;
        this.TofkMinfinKey.Value = null;
        this._infoSheetsCount.Value = null;
        this._docSheetsCount.Value = null;
        this.IsPortable.Value = null;
        this._protocolNum.Value = null;
        this._protocolDate.Value = null;
        this.ProtocolEmployee.RecordKey.Value = null;
        this.RegistryCode.Value = null;
        this.RegistryDate.Value = null;
        this.UpdateRequisites();
    };
    BankGuaranteesTable.prototype.GenerateBody = function () {
        var _this = this;
        if (this._providerNode == null) {
            this._providerNode = new ChoiceNodeXmlElementInfo();
        }
        this.ExportNode.AddAttrNode(new AttributeXmlElementInfo("msgId", new StringXmlElementType(32), function () { return _this.FtMessageId.Value; }, true, "Идентификатор сообщения", this.FtMessageId.Value));
        this.ExportNode.AddAttrNode(new AttributeXmlElementInfo("msgVer", new XmlElementType("integer"), function () { return _this.FtMessageVerField.Value; }, true, "Версия сообщения", this.FtMessageVerField.Value));
        var result = [];
        result.push(this.CreateDateField.GenerateNode());
        result.push(this.RowNumber.GenerateNode());
        result.push(this.SecurityType.GenerateNode());
        result.push(TableCollection.BankTable.GenerateNode());
        result.push(TableCollection.CustomerTable.GenerateNode());
        result.push(this.ProviderTypeField.GenerateNode("ProviderType"));
        this._providerNode.AddChildNode(TableCollection.LegalEntityProviderTable.GenerateNode());
        this._providerNode.AddChildNode(TableCollection.IndividualBusinessmanTable.GenerateNode());
        this._providerNode.AddChildNode(TableCollection.ForeignCitizenTable.GenerateNode());
        this._providerNode.AddChildNode(TableCollection.ForeignLegalEntityProviderTable.GenerateNode());
        result.push(this._providerNode);
        result.push(this.Okv.GenerateNode());
        result.push(this.Rate.GenerateNode());
        result.push(this.UsdValue.GenerateNode());
        result.push(this._rubValue.GenerateNode());
        result.push(this.PurchaseCode.GenerateNode());
        result.push(this.Code.GenerateNode());
        result.push(this.IssueDate.GenerateNode());
        var childNode = new ComplexNodeXmlElementInfo("Entry");
        childNode.AddChildNode(this._entryDate.GenerateNode("Date"));
        childNode.AddChildNode(this._entryCondition.GenerateNode("Condition"));
        result.push(childNode);
        childNode = new ComplexNodeXmlElementInfo("Expiry");
        childNode.AddChildNode(this._expiryDate.GenerateNode("Date"));
        childNode.AddChildNode(this._expiryCondition.GenerateNode("Condition"));
        result.push(childNode);
        result.push(this.BankEmployee.GenerateNode());
        var simpleChildNode = new SimpleNodeXmlElementInfo("IsChange", new BooleanXmlElementType(), function () { return _this._ownerKey.Value !== null; }, this._ownerKey.Value !== null, true, 1, "Признак изменения");
        result.push(simpleChildNode);
        childNode = new ComplexNodeXmlElementInfo("OwnerRegisterRecord");
        childNode.AddChildNode(this._ownerRegCode.GenerateNode("Code"));
        childNode.AddChildNode(this._ownerRegDate.GenerateNode("Date"));
        result.push(childNode);
        result.push(this.Docs.GenerateNode());
        return result;
    };
    BankGuaranteesTable.prototype.ExportTemplate = function (nodeId) {
        this._providerNode = new ChoiceNodeXmlElementInfo();
        TableCollection.BankTable.LocateByKeys(this.BankKey.Value);
        TableCollection.CustomerTable.LocateByKeys(this.CustomerKey.Value);
        switch (this.ProviderType) {
            case ProviderTypes.LegalEntity:
                TableCollection.LegalEntityProviderTable.LocateByKeys(this.LegalEntityProvider.Value);
                this._providerNode.ExportIndex = 0;
                break;
            case ProviderTypes.IndividualBusinessman:
                TableCollection.IndividualBusinessmanTable.LocateByKeys(this.IndividualProvider.Value);
                this._providerNode.ExportIndex = 1;
                break;
            case ProviderTypes.ForeignCitizen:
                TableCollection.ForeignCitizenTable.LocateByKeys(this.ForeignCitizenProvider.Value);
                this._providerNode.ExportIndex = 2;
                break;
            case ProviderTypes.ForeignLegalEntity:
                TableCollection.ForeignLegalEntityProviderTable.LocateByKeys(this.ForeignLegalProvider.Value);
                this._providerNode.ExportIndex = 3;
                break;
        }
        this.Docs.ExportBankGuaramtiesKey = this.RecordKey.Value;
        var result = _super.prototype.ExportTemplate.call(this, nodeId);
        if (!ObasHelper.IsGenerateToXsd) {
            this.FtMessageCanExport.Value = false;
            this.FtMessageVerField.Value++;
        }
        this._providerNode = null;
        return result;
    };
    BankGuaranteesTable.prototype.UpdateRequisites = function () {
        if (this.Status === DataStatuses.Draft && !this.IsArched) {
            var date = this.CreateDate;
            this.BankKey.UpdateReference(date);
            this.TofkKey.UpdateReference(date);
            this.CustomerKey.UpdateReference(date);
            switch (this.ProviderType) {
                case ProviderTypes.LegalEntity:
                    this.LegalEntityProvider.UpdateReference(date);
                    break;
                case ProviderTypes.IndividualBusinessman:
                    this.IndividualProvider.UpdateReference(date);
                    break;
                case ProviderTypes.ForeignCitizen:
                    this.ForeignCitizenProvider.UpdateReference(date);
                    break;
                case ProviderTypes.ForeignLegalEntity:
                    this.ForeignLegalProvider.UpdateReference(date);
                    break;
            }
        }
    };
    BankGuaranteesTable.prototype.UpdateAllDraftRequisites = function () {
        var locateFields = this.StatusField.ForeignKey.Id;
        var locateKeys = DataStatuses.Draft;
        while (this.Locate(locateFields, locateKeys, true)) {
            this.UpdateRequisites();
        }
        this.ClearLocateFlag();
    };
    BankGuaranteesTable.prototype.CreateNewVersion = function (sourceKey) {
        if (this.LocateByKeys(sourceKey)) {
            var srcStatus = this.Status;
            var newKey = this.CloneRow();
            if (this.RecordKey.Value !== sourceKey) {
                var ownerRegCode = this.RegistryCode.Value;
                var ownerRegDate = this.RegistryDate.Value;
                this.Docs.CopyDocuments(sourceKey, newKey);
                this.StatusField.ForeignKey.Value = DataStatuses.Draft;
                this.RowNumber.Value = TableCollection.SequenceTable.GetCurrentKey(this);
                this.FtRegNum.Value = null;
                this.FtReceivedDate.Value = null;
                this._infoSheetsCount.Value = null;
                this._docSheetsCount.Value = null;
                this._isPortable.Value = null;
                this.FtEmployee.RecordKey.Value = null;
                if (srcStatus !== DataStatuses.Included) {
                    this.RegistryCode.Value = null;
                    this._regDate.Value = null;
                }
                this.StatementDate.Value = null;
                this.StatementNum.Value = null;
                this._protocolDate.Value = null;
                this._protocolNum.Value = null;
                this._ownerKey.Value = sourceKey;
                this.OwnerRegistryCode.Value = ownerRegCode;
                this.OwnerRegistryDate.Value = ownerRegDate;
                this.UpdateRequisites();
            }
        }
    };
    BankGuaranteesTable.prototype.CalcOkopf = function (fieldId) {
        if (this.ProviderType === ProviderTypes.LegalEntity) {
            var providerTable = TableCollection.LegalEntityProviderTable;
            if (providerTable.LocateByKeys(this.LegalEntityProvider.Value)) {
                return providerTable.Okopf[fieldId];
            }
        }
        return "";
    };
    BankGuaranteesTable.prototype.CalcProviderShortName = function () {
        var providerTable = this.OrgProvider;
        if (providerTable != null) {
            return providerTable.ShortName.Value;
        }
        else {
            return "";
        }
    };
    BankGuaranteesTable.prototype.CalcForeignCountryName = function () {
        var providerTable = this.ForeignProvider;
        if (providerTable != null) {
            return providerTable.ForeignData.Oksm.Name;
        }
        else {
            return "";
        }
    };
    BankGuaranteesTable.prototype.CalcForeignCountryCode = function () {
        var providerTable = this.ForeignProvider;
        if (providerTable != null) {
            return providerTable.ForeignData.Oksm.Code;
        }
        else {
            return "";
        }
    };
    BankGuaranteesTable.prototype.CalcForeignRegStruct = function () {
        var providerTable = this.ForeignProvider;
        if (providerTable != null) {
            return providerTable.ForeignData.RegStruct.toString();
        }
        else {
            return "";
        }
    };
    BankGuaranteesTable.prototype.CalcForeignCity = function () {
        var providerTable = this.ForeignProvider;
        if (providerTable != null) {
            return providerTable.ForeignData.CityName.toString();
        }
        else {
            return "";
        }
    };
    BankGuaranteesTable.prototype.CalcForeignStruct = function () {
        var providerTable = this.ForeignProvider;
        if (providerTable != null) {
            return providerTable.ForeignData.FullStruct;
        }
        else {
            return "";
        }
    };
    BankGuaranteesTable.prototype.CalcForeignStreet = function () {
        var providerTable = this.ForeignProvider;
        if (providerTable != null) {
            return providerTable.ForeignData.FullStreet;
        }
        else {
            return "";
        }
    };
    BankGuaranteesTable.prototype.CalcForeignHouse = function () {
        var providerTable = this.ForeignProvider;
        if (providerTable != null) {
            return providerTable.ForeignData.FullHouse;
        }
        else {
            return "";
        }
    };
    BankGuaranteesTable.prototype.CalcForeignRoom = function () {
        var providerTable = this.ForeignProvider;
        if (providerTable != null) {
            return providerTable.ForeignData.FullRoom;
        }
        else {
            return "";
        }
    };
    BankGuaranteesTable.prototype.CalcForeignPostCode = function () {
        var providerTable = this.ForeignProvider;
        if (providerTable != null) {
            return providerTable.ForeignData.PostCode.toString();
        }
        else {
            return "";
        }
    };
    BankGuaranteesTable.prototype.ExportDocuments = function () {
        var result = [];
        while (this.Docs.Locate(this.Docs.BankGuaranteesKey.Id, this.RecordKey.Value, true)) {
            var docInfo = "";
            switch (this.Docs.DocumentType) {
                case DocumentTypes.Original:
                    docInfo += "Оригинал";
                    break;
                case DocumentTypes.Copy:
                    docInfo += "Копия";
                    break;
                case DocumentTypes.Proxy:
                    docInfo += "Доверенность";
                    break;
            }
            if (this.Docs.DocumentType !== DocumentTypes.Proxy) {
                docInfo += " (наименование документа(ов) " + this.Docs.Name.Value;
            }
            docInfo += " в количестве " + this.Docs.CopiesCount.Value + " экз., на " + this.Docs.SheetsCount.Value + " л.";
            result.push(docInfo);
        }
        this.Docs.ClearLocateFlag();
        if (result.length === 0) {
            result.push("Доверенность в количестве ___ экз., на ___ л.");
        }
        return result.join("\n");
    };
    BankGuaranteesTable.prototype.GetValueForExport = function (param, statuses) {
        var acceptedStatuses = statuses ? statuses.split("|") : null;
        if (!acceptedStatuses || acceptedStatuses.indexOf(this.Status.toString()) > -1) {
            return _super.prototype.GetValueForExport.call(this, param);
        }
        return "";
    };
    BankGuaranteesTable.prototype.UsdValueChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
        this.FtFieldsChangeEventHandler(tableId, oldValue, newValue, fieldId);
        this._rubValue.Value = (this.UsdValue.Value || 0) * (this._rate.Value || 0);
    };
    BankGuaranteesTable.prototype.StatusChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
        switch (this.Status) {
            case DataStatuses.Ready:
                this.CreateDateField.Value = this.InitCreateDate;
                break;
            case DataStatuses.Draft:
                this.CreateDateField.Value = undefined;
                break;
        }
    };
    BankGuaranteesTable.prototype.EntryDateCheckEventHandler = function (tableId, fieldId) {
        return this.DateCheckEventHandler(this._entryDate, this.IssueDate);
    };
    BankGuaranteesTable.prototype.ExpiryDateCheckEventHandler = function (tableId, fieldId) {
        return this.DateCheckEventHandler(this._expiryDate, this._entryDate);
    };
    BankGuaranteesTable.prototype.ProtocolDateCheckEventHandler = function (tableId, fieldId) {
        return this.DateCheckEventHandler(this._protocolDate, this.FtReceivedDate, true);
    };
    BankGuaranteesTable.prototype.RegDateCheckEventHandler = function (tableId, fieldId) {
        return this.DateCheckEventHandler(this._regDate, this.FtReceivedDate, true);
    };
    BankGuaranteesTable.prototype.StatementDateCheckEventHandler = function (tableId, fieldId) {
        return this.DateCheckEventHandler(this.StatementDate, this.RegistryDate, true);
    };
    return BankGuaranteesTable;
}(BaseBankGuarantees));
BankGuaranteesTable._xlsTemplate = {
    TemplateName: "InfoApp.xls",
    FileName: "Приложение 1"
};
var BankGuaranteesDocsTable = (function (_super) {
    __extends(BankGuaranteesDocsTable, _super);
    function BankGuaranteesDocsTable(mainTable) {
        var _this = _super.call(this, "BankGuaranteesDocs", "Documents") || this;
        _this._docType = null;
        _this._childExportNode = null;
        _this.ExportBankGuaramtiesKey = null;
        _this._name = new ObasTableField("Name", _this);
        _this._copies = new NumberObasTableField("CopiesCount", _this);
        _this._sheets = new NumberObasTableField("SheetsCount", _this);
        _this._bankGuarantees = new ObasForeignKeyTableField(mainTable, _this);
        return _this;
    }
    Object.defineProperty(BankGuaranteesDocsTable.prototype, "Name", {
        get: function () {
            return this._name;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesDocsTable.prototype, "CopiesCount", {
        get: function () {
            return this._copies;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesDocsTable.prototype, "SheetsCount", {
        get: function () {
            return this._sheets;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesDocsTable.prototype, "BankGuaranteesKey", {
        get: function () {
            return this._bankGuarantees;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesDocsTable.prototype, "DocumentType", {
        get: function () {
            return this.DocType.ForeignKey.Value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesDocsTable.prototype, "DocType", {
        get: function () {
            if (this._docType == null) {
                this._docType = new ObasSprTableField(TableCollection.DocumentTypesSprTable, this);
            }
            return this._docType;
        },
        enumerable: true,
        configurable: true
    });
    BankGuaranteesDocsTable.prototype.GenerateChildNode = function () {
        var result = new ComplexNodeXmlElementInfo("Doc", "Документ", false, Number.MAX_VALUE);
        result.AddChildNode(this.DocType.GenerateNode());
        result.AddChildNode(this.Name.GenerateNode());
        result.AddChildNode(this.CopiesCount.GenerateNode());
        result.AddChildNode(this.SheetsCount.GenerateNode());
        return result;
    };
    BankGuaranteesDocsTable.prototype.GenerateBody = function () {
        var _this = this;
        var result = [];
        if (this._childExportNode == null) {
            var generateChildNodes = function () {
                var data = [];
                while (_this.Locate(_this.BankGuaranteesKey.Id, _this.ExportBankGuaramtiesKey, true)) {
                    data.push(_this.GenerateChildNode());
                }
                _this.ClearLocateFlag();
                return data;
            };
            this._childExportNode = new UnboundNodeXmlElementInfo(this.GenerateChildNode(), generateChildNodes);
        }
        result.push(this._childExportNode);
        return result;
    };
    BankGuaranteesDocsTable.prototype.CreateExportTemplate = function (bankGuaranteesKey) {
        this.ExportBankGuaramtiesKey = bankGuaranteesKey;
        return ObasHelper.GenerateExportTemplate(this.GenerateNode());
    };
    BankGuaranteesDocsTable.prototype.CopyDocuments = function (srcGuaranteesKey, destGuaranteesKey) {
        while (this.Locate(this.BankGuaranteesKey.Id, srcGuaranteesKey, true)) {
            this.CloneRow();
            this.BankGuaranteesKey.Value = destGuaranteesKey;
        }
        this.ClearLocateFlag();
    };
    BankGuaranteesDocsTable.prototype.IsNotProxy = function () {
        return this.DocumentType !== DocumentTypes.Proxy;
    };
    return BankGuaranteesDocsTable;
}(BaseEntityTable));
