﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var BankGuaranteesRequestTable = (function (_super) {
    __extends(BankGuaranteesRequestTable, _super);
    function BankGuaranteesRequestTable(document) {
        var _this = _super.call(this, "BankGuaranteesRequest", document) || this;
        _this._declarerKey = null;
        _this._bankShortKey = null;
        _this._stateType = null;
        _this._methodType = null;
        _this._declarerEmployee = null;
        _this._declarerNode = null;
        _this._declarerEmployeeNode = null;
        _this._providerNode = null;
        _this._reason = new ObasTableField("GetReason", _this);
        _this._fullUsdValue = new ObasTableField("FullUsdValue", _this);
        _this.SetEvents();
        return _this;
    }
    Object.defineProperty(BankGuaranteesRequestTable.prototype, "GetReason", {
        get: function () {
            return this._reason;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesRequestTable.prototype, "StatementType", {
        get: function () {
            if (this._stateType == null) {
                this._stateType = new ObasSprTableField(TableCollection.StatementTypesSprTable, this);
            }
            return this._stateType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesRequestTable.prototype, "MethodType", {
        get: function () {
            if (this._methodType == null) {
                this._methodType = new ObasSprTableField(TableCollection.GetInfoMethodsTypesSprTable, this);
            }
            return this._methodType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesRequestTable.prototype, "OrgProvider", {
        get: function () {
            var providerTable;
            var providerKey = -1;
            switch (this.ProviderType) {
                case ProviderTypes.LegalEntity:
                    providerTable = TableCollection.LegalEntityProviderShortTable;
                    providerKey = this.LegalEntityProvider.Value;
                    break;
                case ProviderTypes.ForeignLegalEntity:
                    providerTable = TableCollection.ForeignLegalEntityProviderShortTable;
                    providerKey = this.ForeignLegalProvider.Value;
                    break;
            }
            if (providerTable != null && providerTable.LocateByKeys(providerKey)) {
                return providerTable;
            }
            else {
                return null;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesRequestTable.prototype, "ForeignProvider", {
        get: function () {
            var providerTable;
            var providerKey = -1;
            switch (this.ProviderType) {
                case ProviderTypes.ForeignCitizen:
                    providerTable = TableCollection.ForeignCitizenShortTable;
                    providerKey = this.ForeignCitizenProvider.Value;
                    break;
                case ProviderTypes.ForeignLegalEntity:
                    providerTable = TableCollection.ForeignLegalEntityProviderShortTable;
                    providerKey = this.ForeignLegalProvider.Value;
                    break;
            }
            if (providerTable != null && providerTable.LocateByKeys(providerKey)) {
                return providerTable;
            }
            else {
                return null;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesRequestTable.prototype, "DeclarerEmployee", {
        get: function () {
            if (this._declarerEmployee == null) {
                this._declarerEmployee = new EmployeeFields(this, "Declarer");
            }
            return this._declarerEmployee;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesRequestTable.prototype, "BankShortKey", {
        get: function () {
            if (this._bankShortKey == null) {
                this._bankShortKey = new VersionElementForeignKeyTableField(TableCollection.BankShortTable, this);
            }
            return this._bankShortKey;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesRequestTable.prototype, "Status", {
        get: function () {
            return (this.StatusField.ForeignKey.Value || RequestStatuses.Draft);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesRequestTable.prototype, "DeclarerKey", {
        get: function () {
            if (this._declarerKey == null) {
                this._declarerKey = new VersionElementForeignKeyTableField(TableCollection.DeclarerTable, this);
            }
            return this._declarerKey;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesRequestTable.prototype, "DeclarerTable", {
        get: function () {
            switch (this._document.AssemblyType) {
                case AssemblyTypes.Full:
                    return this.BankKey.SourceTable;
                case AssemblyTypes.OnlyRequest:
                    return this.DeclarerKey.SourceTable;
                default:
                    return null;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BankGuaranteesRequestTable.prototype, "CurrentEmployee", {
        get: function () {
            if (this._document.AssemblyType === AssemblyTypes.Full) {
                return this.BankEmployee;
            }
            else {
                return this.DeclarerEmployee;
            }
        },
        enumerable: true,
        configurable: true
    });
    BankGuaranteesRequestTable.prototype.SetEvents = function () {
        TableCollection.LegalEntityProviderShortTable.SignNotif(this.LegalEntitySprTableEdited.bind(this));
        TableCollection.IndividualBusinessmanShortTable.SignNotif(this.IndividualSprTableEdited.bind(this));
        TableCollection.ForeignCitizenShortTable.SignNotif(this.ForeignCitizenSprTableEdited.bind(this));
        TableCollection.ForeignLegalEntityProviderShortTable.SignNotif(this.ForeignLegalEntitySprTableEdited.bind(this));
        TableCollection.CustomerShortTable.SignNotif(this.CustomerShortSprTableEdited.bind(this));
        TableCollection.BankShortTable.SignNotif(this.BankShortSprTableEdited.bind(this));
    };
    BankGuaranteesRequestTable.prototype.InitLegalEntity = function () {
        return new ProviderKeyTableField(TableCollection.LegalEntityProviderShortTable, this, "LegalEntityProvider");
    };
    BankGuaranteesRequestTable.prototype.InitIndividual = function () {
        return new ProviderKeyTableField(TableCollection.IndividualBusinessmanShortTable, this, "IndividualBusinessmanProvider");
    };
    BankGuaranteesRequestTable.prototype.InitForeignCitizeny = function () {
        return new ProviderKeyTableField(TableCollection.ForeignCitizenShortTable, this, "ForeignCitizenProvider");
    };
    BankGuaranteesRequestTable.prototype.InitForeignLegal = function () {
        return new ProviderKeyTableField(TableCollection.ForeignLegalEntityProviderShortTable, this, "ForeignLegalEntityProvider");
    };
    BankGuaranteesRequestTable.prototype.InitCustomer = function () {
        return new VersionElementForeignKeyTableField(TableCollection.CustomerShortTable, this, "CustomerDetails");
    };
    BankGuaranteesRequestTable.prototype.InitStatusField = function () {
        return new ObasSprTableField(TableCollection.RequestStatusesSprTable, this);
    };
    BankGuaranteesRequestTable.prototype.DoAfterCopy = function (sourceKey) {
        this.UpdateRequisites();
    };
    BankGuaranteesRequestTable.prototype.GetXlsTemplate = function () {
        return BankGuaranteesRequestTable._xlsTemplate;
    };
    BankGuaranteesRequestTable.prototype.GetMethodTypeMark = function (methodTypeId) {
        if (this.MethodType.ForeignKey.Value != null && this.MethodType.ForeignKey.Value.toString() === methodTypeId.toString()) {
            return "X";
        }
        return "";
    };
    BankGuaranteesRequestTable.prototype.CheckInfoMethod = function (tableId) {
        if (this.MethodType.ForeignKey.Value === MethodTypes.Site) {
            return "Способ получения информации \"В личном кабинете на официальном сайте единой информационной системы в сфере закупок\" не доступен в соответствии с требованиями приказа Минфина России от 27.07.2016 N 125н";
        }
        return undefined;
    };
    BankGuaranteesRequestTable.prototype.CalcFullUsdValue = function () {
        var result = ObasHelper.ConvertToString(this.UsdValue.NValue, this.UsdValue.Precision);
        var okvName = this.Okv.Name;
        if (result && okvName) {
            result += " ";
        }
        result += okvName ? "(" + okvName + ")" : "";
        return result;
    };
    BankGuaranteesRequestTable.prototype.GenerateBody = function () {
        var _this = this;
        if (this._providerNode == null) {
            this._providerNode = new ChoiceNodeXmlElementInfo();
        }
        if (this._declarerNode == null) {
            this._declarerNode = new ChoiceNodeXmlElementInfo();
        }
        if (this._declarerEmployeeNode == null) {
            this._declarerEmployeeNode = new ChoiceNodeXmlElementInfo();
        }
        this.ExportNode.AddAttrNode(new AttributeXmlElementInfo("msgId", new StringXmlElementType(32), function () { return _this.FtMessageId.Value; }, true, "Идентификатор сообщения", this.FtMessageId.Value));
        this.ExportNode.AddAttrNode(new AttributeXmlElementInfo("msgVer", new XmlElementType("integer"), function () { return _this.FtMessageVerField.Value; }, true, "Версия сообщения", this.FtMessageVerField.Value));
        var result = [];
        result.push(this.CreateDateField.GenerateNode());
        result.push(this.RowNumber.GenerateNode());
        result.push(this.SecurityType.GenerateNode());
        var simpleChildNode = new SimpleNodeXmlElementInfo("IsFullAssembly", new BooleanXmlElementType(), function () { return _this._document.InterfaceRules.IsFullAssembly(); }, this._document.InterfaceRules.IsFullAssembly(), true, 1, "Признак полной сборки");
        result.push(simpleChildNode);
        TableCollection.BankTable.IsRequestMode = true;
        this._declarerNode.AddChildNode(TableCollection.DeclarerTable.GenerateNode());
        this._declarerNode.AddChildNode(TableCollection.BankTable.GenerateNode());
        result.push(this._declarerNode);
        this._declarerEmployeeNode.AddChildNode(this.DeclarerEmployee.GenerateNode());
        this._declarerEmployeeNode.AddChildNode(this.BankEmployee.GenerateNode());
        result.push(this._declarerEmployeeNode);
        TableCollection.BankTable.IsRequestMode = false;
        result.push(TableCollection.BankShortTable.GenerateNode());
        result.push(TableCollection.CustomerShortTable.GenerateNode());
        result.push(this.ProviderTypeField.GenerateNode("ProviderType"));
        this._providerNode.AddChildNode(TableCollection.LegalEntityProviderShortTable.GenerateNode());
        this._providerNode.AddChildNode(TableCollection.IndividualBusinessmanShortTable.GenerateNode());
        this._providerNode.AddChildNode(TableCollection.ForeignCitizenShortTable.GenerateNode());
        this._providerNode.AddChildNode(TableCollection.ForeignLegalEntityProviderShortTable.GenerateNode());
        result.push(this._providerNode);
        var tofkTable;
        if (this.IsUserTofk.Value) {
            tofkTable = TableCollection.TofkTable;
        }
        else {
            tofkTable = TableCollection.TofkMinfinTable;
        }
        tofkTable.IsRequestMode = true;
        result.push(tofkTable.GenerateNode());
        tofkTable.IsRequestMode = false;
        result.push(this.RegistryCode.GenerateNode("RegisterRecordCode"));
        result.push(this.Okv.GenerateNode());
        result.push(this.UsdValue.GenerateNode());
        result.push(this.Code.GenerateNode());
        result.push(this.IssueDate.GenerateNode());
        result.push(this.PurchaseCode.GenerateNode());
        var descNode = new ComplexNodeXmlElementInfo("GetDesc");
        descNode.AddChildNode(this._reason.GenerateNode("Reason"));
        descNode.AddChildNode(this.StatementType.GenerateNode());
        descNode.AddChildNode(this.MethodType.GenerateNode());
        result.push(descNode);
        return result;
    };
    BankGuaranteesRequestTable.prototype.ExportTemplate = function (nodeId) {
        this._providerNode = new ChoiceNodeXmlElementInfo();
        this._declarerNode = new ChoiceNodeXmlElementInfo();
        this._declarerEmployeeNode = new ChoiceNodeXmlElementInfo();
        switch (this._document.AssemblyType) {
            case AssemblyTypes.OnlyRequest:
                TableCollection.DeclarerTable.LocateByKeys(this.DeclarerKey.Value);
                this._declarerNode.ExportIndex = 0;
                break;
            case AssemblyTypes.Full:
                TableCollection.BankTable.LocateByKeys(this.BankKey.Value);
                this._declarerNode.ExportIndex = 1;
                break;
        }
        this._declarerEmployeeNode.ExportIndex = this._declarerNode.ExportIndex;
        TableCollection.BankShortTable.LocateByKeys(this.BankShortKey.Value);
        TableCollection.CustomerShortTable.LocateByKeys(this.CustomerKey.Value);
        switch (this.ProviderType) {
            case ProviderTypes.LegalEntity:
                TableCollection.LegalEntityProviderShortTable.LocateByKeys(this.LegalEntityProvider.Value);
                this._providerNode.ExportIndex = 0;
                break;
            case ProviderTypes.IndividualBusinessman:
                TableCollection.IndividualBusinessmanShortTable.LocateByKeys(this.IndividualProvider.Value);
                this._providerNode.ExportIndex = 1;
                break;
            case ProviderTypes.ForeignCitizen:
                TableCollection.ForeignCitizenShortTable.LocateByKeys(this.ForeignCitizenProvider.Value);
                this._providerNode.ExportIndex = 2;
                break;
            case ProviderTypes.ForeignLegalEntity:
                TableCollection.ForeignLegalEntityProviderShortTable.LocateByKeys(this.ForeignLegalProvider.Value);
                this._providerNode.ExportIndex = 3;
                break;
        }
        var tofkTable;
        var tofkKey;
        if (this.IsUserTofk.Value) {
            tofkTable = TableCollection.TofkTable;
            tofkKey = this.TofkKey.Value;
        }
        else {
            tofkTable = TableCollection.TofkMinfinTable;
            tofkKey = this.TofkMinfinKey.Value;
        }
        tofkTable.LocateByKeys(tofkKey);
        var result = _super.prototype.ExportTemplate.call(this, nodeId);
        if (!ObasHelper.IsGenerateToXsd) {
            this.FtMessageCanExport.Value = false;
            this.FtMessageVerField.Value++;
        }
        this._providerNode = null;
        this._declarerNode = null;
        this._declarerEmployeeNode = null;
        return result;
    };
    BankGuaranteesRequestTable.prototype.UpdateRequisites = function () {
        if (this.Status === RequestStatuses.Draft && !this.IsArched) {
            var date = this.CreateDate;
            this.BankKey.UpdateReference(date);
            this.TofkKey.UpdateReference(date);
            this.DeclarerKey.UpdateReference(date);
        }
    };
    BankGuaranteesRequestTable.prototype.UpdateAllDraftRequisites = function () {
        var locateFields = this.StatusField.ForeignKey.Id;
        var locateKeys = RequestStatuses.Draft;
        while (this.Locate(locateFields, locateKeys, true)) {
            this.UpdateRequisites();
        }
        this.ClearLocateFlag();
    };
    BankGuaranteesRequestTable.prototype.BankShortSprTableEdited = function (key) {
        this.FtSprTableEdited(this.BankShortKey.Id, key);
    };
    BankGuaranteesRequestTable.prototype.CustomerShortSprTableEdited = function (key) {
        this.FtSprTableEdited(this.CustomerKey.Id, key);
    };
    BankGuaranteesRequestTable.prototype.StatusChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
        switch (this.Status) {
            case RequestStatuses.Ready:
                this.CreateDateField.Value = this.InitCreateDate;
                break;
            case RequestStatuses.Draft:
                this.CreateDateField.Value = undefined;
                break;
        }
    };
    BankGuaranteesRequestTable.prototype.DeclarerDetailsnitEventHandler = function (tableId, fieldId) {
        var sprTable = TableCollection.DeclarerTable;
        if (this._document.AssemblyType === AssemblyTypes.OnlyRequest &&
            sprTable.RowCount > 0 &&
            sprTable.Locate(sprTable.EndDate.Id, undefined)) {
            return sprTable.RecordKey.Value;
        }
        return undefined;
    };
    BankGuaranteesRequestTable.prototype.UsdValueChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
        this.FtFieldsChangeEventHandler(tableId, oldValue, newValue, fieldId);
        this._fullUsdValue.Value = this.CalcFullUsdValue();
    };
    return BankGuaranteesRequestTable;
}(BaseBankGuarantees));
BankGuaranteesRequestTable._xlsTemplate = {
    TemplateName: "RequestApp.xls",
    FileName: "Приложение 4"
};
