﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var BaseEntityTable = (function (_super) {
    __extends(BaseEntityTable, _super);
    function BaseEntityTable(tableId, nodeId) {
        var _this = _super.call(this, tableId) || this;
        _this._exportNode = null;
        _this._nodeId = nodeId || tableId;
        return _this;
    }
    Object.defineProperty(BaseEntityTable.prototype, "NodeId", {
        get: function () {
            return this._nodeId;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseEntityTable.prototype, "ExportNode", {
        get: function () {
            return this._exportNode;
        },
        enumerable: true,
        configurable: true
    });
    BaseEntityTable.prototype.GetValueForExport = function (param) {
        var fields = param.split(".");
        var value = this;
        for (var i = 0; i <= fields.length - 1; i++) {
            if (fields[i].indexOf("toString") !== -1) {
                var params = fields[i].split("<F>");
                if (params.length !== 1) {
                    return value.toString(parseInt(params[1], 10));
                }
                else {
                    return value.toString();
                }
            }
            if (!(fields[i] in value)) {
                throw Error("field " + fields[i] + " not exists");
            }
            else {
                if (value[fields[i]] != null) {
                    value = value[fields[i]];
                }
                else {
                    return "";
                }
            }
        }
        return ObasHelper.ConvertToString(value);
    };
    BaseEntityTable.prototype.CurrentDateFieldCheck = function (dateField) {
        var date = dateField.Value;
        if (date && +date > +(new Date())) {
            return "Значение поля «" + dateField.Caption + "» не может быть больше текущей даты";
        }
        return undefined;
    };
    BaseEntityTable.prototype.CreateExportTemplate = function (recordKey, nodeId) {
        if (this.LocateByKeys(recordKey) || ObasHelper.IsGenerateToXsd) {
            return this.ExportTemplate();
        }
        return "";
    };
    BaseEntityTable.prototype.GenerateNode = function (nodeId, isRequired, maxOccurs) {
        this._exportNode = new ComplexNodeXmlElementInfo(nodeId || this.NodeId, this.Caption, isRequired, maxOccurs);
        this._exportNode.IsRequired = isRequired;
        this._exportNode.AddChildNode(this.GenerateBody());
        this._exportNode.MaxOccurs = maxOccurs;
        return this._exportNode;
    };
    BaseEntityTable.prototype.ExportTemplate = function (nodeId) {
        return ObasHelper.GenerateExportTemplate(this.GenerateNode(nodeId, true));
    };
    BaseEntityTable.prototype.GetExportNameParts = function () {
        var fileNameParts = [];
        var now = new Date();
        fileNameParts.push(this.Id);
        fileNameParts.push(ObasHelper.FillWithCharacter(now.getDate(), 2));
        fileNameParts.push(ObasHelper.FillWithCharacter((now.getMonth() + 1), 2));
        fileNameParts.push(ObasHelper.FillWithCharacter(now.getFullYear(), 2));
        fileNameParts.push(ObasHelper.FillWithCharacter(now.getHours(), 2));
        fileNameParts.push(ObasHelper.FillWithCharacter(now.getMinutes(), 2));
        fileNameParts.push(ObasHelper.FillWithCharacter(now.getSeconds(), 2));
        return fileNameParts;
    };
    BaseEntityTable.prototype.GetExportName = function (delimiter) {
        if (delimiter === void 0) { delimiter = "_"; }
        return this.GetExportNameParts().join(delimiter);
    };
    return BaseEntityTable;
}(ObasTable));
var BaseVersionEntityTable = (function (_super) {
    __extends(BaseVersionEntityTable, _super);
    function BaseVersionEntityTable(tableId, nodeId) {
        var _this = _super.call(this, tableId, nodeId) || this;
        _this._startDateValue = null;
        _this._endDateValue = null;
        _this._startDateIndex = null;
        _this._locateFields = null;
        _this._locateKeys = null;
        _this._startDate = new ObasTableField("StartDate", _this);
        _this._endDate = new ObasTableField("EndDate", _this);
        return _this;
    }
    Object.defineProperty(BaseVersionEntityTable, "FirstStartDate", {
        get: function () {
            return BaseVersionEntityTable._firstStartDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseVersionEntityTable.prototype, "StartDateIndex", {
        get: function () {
            if (this._startDateIndex == null) {
                this._startDateIndex = this.LocateFields.indexOf(this.StartDate.Id);
            }
            return this._startDateIndex;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseVersionEntityTable.prototype, "StartDate", {
        get: function () {
            return this._startDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseVersionEntityTable.prototype, "EndDate", {
        get: function () {
            return this._endDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseVersionEntityTable.prototype, "LocateFields", {
        get: function () {
            if (this._locateFields == null) {
                this._locateFields = this.GetLocateFields();
            }
            return this._locateFields;
        },
        enumerable: true,
        configurable: true
    });
    BaseVersionEntityTable.prototype.GetLocateKeys = function () {
        var keys = [];
        for (var i = 0, len = this.LocateFields.length; i < len; i++) {
            keys.push(this.GetFieldValue(this.LocateFields[i]));
        }
        return keys;
    };
    BaseVersionEntityTable.prototype.CreateNewVersion = function (srcKey) {
        if (this.LocateByKeys(srcKey)) {
            var closeDate = new Date();
            closeDate.setMilliseconds(0);
            var locateKeys = this.GetLocateKeys();
            locateKeys.splice(this.StartDateIndex, 1);
            this.FindElementKey(closeDate, locateKeys);
            closeDate.setSeconds(closeDate.getSeconds() - 1);
            this.EndDate.Value = closeDate;
            var destKey = this.CloneRow(srcKey);
            closeDate.setSeconds(closeDate.getSeconds() + 1);
            this.StartDate.Value = closeDate;
            this.EndDate.Value = undefined;
            return destKey;
        }
        return undefined;
    };
    BaseVersionEntityTable.prototype.StartDateInitEventHandler = function (tableId, fieldId) {
        return BaseVersionEntityTable.FirstStartDate.toJSON();
    };
    BaseVersionEntityTable.prototype.EndDateInitEventHandler = function (tableId, fieldId) {
        return new Date(2099, 11, 31, 23, 59, 59).toJSON();
    };
    BaseVersionEntityTable.prototype.DeleteEventHandler = function (tableId) {
        this._startDateValue = this.StartDate.Value;
        this._endDateValue = this.EndDate.Value;
        this._locateKeys = this.GetLocateKeys();
    };
    BaseVersionEntityTable.prototype.AfterDeleteEventHandler = function (tableId) {
        var startFieldId = this.StartDate.Id;
        var filteredFields = this.GetLocateFields().filter(function (value) {
            return value !== startFieldId;
        });
        filteredFields.push(this.EndDate.Id);
        this._startDateValue.setSeconds(this._startDateValue.getSeconds() - 1);
        this._locateKeys.splice(this.StartDateIndex, 1);
        this._locateKeys.push(this._startDateValue);
        if (this.Locate(filteredFields, this._locateKeys)) {
            this.EndDate.Value = this._endDateValue;
        }
    };
    BaseVersionEntityTable.prototype.FindElementKey = function (date, locateKeys, inLocateFields) {
        var result = undefined;
        var startFieldId = this.StartDate.Id;
        var checkDate = +date;
        var locateFields = inLocateFields || this.GetLocateFields().filter(function (value) {
            return value !== startFieldId;
        });
        while (this.Locate(locateFields, locateKeys, true)) {
            var endDate = this.EndDate.Value;
            if ((+this.StartDate.Value <= checkDate &&
                (endDate == null || +endDate >= checkDate)) ||
                (endDate == null && date == null)) {
                result = this.RecordKey.Value;
                break;
            }
        }
        this.ClearLocateFlag();
        return result;
    };
    return BaseVersionEntityTable;
}(BaseEntityTable));
BaseVersionEntityTable._firstStartDate = new Date(2000, 0, 1);
var AddressFields = (function () {
    function AddressFields(source, prefix) {
        this._oksm = null;
        this._structType = null;
        this._streetType = null;
        this._houseType = null;
        this._roomType = null;
        this._exportNode = null;
        this._prefix = prefix || "";
        this._source = source;
        this._inn = new ObasTableField(this._prefix + "Inn", this.Source);
        this._cityName = new ObasTableField(this._prefix + "CityName", source);
        this._structName = new ObasTableField(this._prefix + "StructName", source);
        this._streetName = new ObasTableField(this._prefix + "StreetName", source);
        this._houseNum = new ObasTableField(this._prefix + "HouseNum", source);
        this._roomNum = new ObasTableField(this._prefix + "RoomNum", source);
    }
    Object.defineProperty(AddressFields.prototype, "Source", {
        get: function () {
            return this._source;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "Inn", {
        get: function () {
            return this._inn;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "CityName", {
        get: function () {
            return this._cityName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "StructName", {
        get: function () {
            return this._structName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "StreetName", {
        get: function () {
            return this._streetName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "HouseNum", {
        get: function () {
            return this._houseNum;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "RoomNum", {
        get: function () {
            return this._roomNum;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "Oksm", {
        get: function () {
            if (this._oksm == null) {
                this._oksm = new ObasSprTableField(TableCollection.OksmSprTable, this._source, this._prefix + "OKSM");
            }
            return this._oksm;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "StructType", {
        get: function () {
            if (this._structType == null) {
                this._structType = new ObasSprTableField(TableCollection.PlanningStructureTypesSprTable, this._source, this._prefix + "StructType");
            }
            return this._structType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "StreetType", {
        get: function () {
            if (this._streetType == null) {
                this._streetType = new ObasSprTableField(TableCollection.RoadNetworkTypesSprTable, this._source, this._prefix + "StreetType");
            }
            return this._streetType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "HouseType", {
        get: function () {
            if (this._houseType == null) {
                this._houseType = new ObasSprTableField(TableCollection.AddressTypesSprTable, this._source, this._prefix + "HouseType");
            }
            return this._houseType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "RoomType", {
        get: function () {
            if (this._roomType == null) {
                this._roomType = new ObasSprTableField(TableCollection.AddressTypesSprTable, this._source, this._prefix + "RoomType");
            }
            return this._roomType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "FullStruct", {
        get: function () {
            return (this.StructType.Code || "") + " " + (this.StructName.Value || "");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "FullStreet", {
        get: function () {
            return (this.StreetType.Code || "") + " " + (this.StreetName.Value || "");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "FullHouse", {
        get: function () {
            return (this.HouseType.Code || "") + " " + (this.HouseNum.Value || "");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AddressFields.prototype, "FullRoom", {
        get: function () {
            return (this.RoomType.Code || "") + " " + (this.RoomNum.Value || "");
        },
        enumerable: true,
        configurable: true
    });
    AddressFields.prototype.ExportTemplate = function () {
        var result = "";
        var nodes = this.GenerateNode().Childs;
        for (var i = 0, len = nodes.length; i < len; i++) {
            result += ObasHelper.GenerateExportTemplate(nodes[i]);
        }
        return result;
    };
    AddressFields.prototype.GenerateNode = function (nodeId, isRequired, maxOccurs) {
        var _this = this;
        if (isRequired === void 0) { isRequired = false; }
        if (maxOccurs === void 0) { maxOccurs = 1; }
        var nodeName = nodeId || (this._prefix.length > 0 ? this._prefix : "Fields");
        this._exportNode = new ComplexNodeXmlElementInfo(nodeName, null, isRequired, maxOccurs);
        this._exportNode.AddChildNode(this.Inn.GenerateNode());
        this._exportNode.AddChildNode(this.Oksm.GenerateNode());
        this._exportNode.AddChildNode(this.CityName.GenerateNode());
        var childGenerator = function (name) {
            var childNode = new ComplexNodeXmlElementInfo("" + _this._prefix + name);
            childNode.AddChildNode(_this[name + "Type"].GenerateNode("Type"));
            childNode.AddChildNode(_this[name + "Name"].GenerateNode("Name"));
            _this._exportNode.AddChildNode(childNode);
        };
        var childNumGenerator = function (name) {
            var childNode = new ComplexNodeXmlElementInfo("" + _this._prefix + name);
            childNode.AddChildNode(_this[name + "Type"].GenerateNode("Type"));
            childNode.AddChildNode(_this[name + "Num"].GenerateNode("Num"));
            _this._exportNode.AddChildNode(childNode);
        };
        childGenerator("Struct");
        childGenerator("Street");
        childNumGenerator("House");
        childNumGenerator("Room");
        return this._exportNode;
    };
    return AddressFields;
}());
var ForeignFields = (function (_super) {
    __extends(ForeignFields, _super);
    function ForeignFields(source) {
        var _this = _super.call(this, source, "Foreign") || this;
        _this._postCode = new ObasTableField("ForeignPostCode", _this.Source);
        _this._regStruct = new ObasTableField("ForeignRegStructName", _this.Source);
        return _this;
    }
    Object.defineProperty(ForeignFields.prototype, "PostCode", {
        get: function () {
            return this._postCode;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ForeignFields.prototype, "RegStruct", {
        get: function () {
            return this._regStruct;
        },
        enumerable: true,
        configurable: true
    });
    ForeignFields.prototype.GenerateNode = function (nodeId, isRequired, maxOccurs) {
        var result = _super.prototype.GenerateNode.call(this, nodeId, isRequired, maxOccurs);
        result.AddChildNode(this.PostCode.GenerateNode());
        result.AddChildNode(this.RegStruct.GenerateNode());
        return result;
    };
    return ForeignFields;
}(AddressFields));
var TaxFields = (function (_super) {
    __extends(TaxFields, _super);
    function TaxFields(source) {
        var _this = _super.call(this, source) || this;
        _this._oktmo = null;
        _this._subject = null;
        _this._postCode = new NumberObasTableField("PostCode", _this.Source);
        _this._districtName = new ObasTableField("DistrictName", _this.Source);
        return _this;
    }
    Object.defineProperty(TaxFields.prototype, "PostCode", {
        get: function () {
            return this._postCode;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TaxFields.prototype, "DistrictName", {
        get: function () {
            return this._districtName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TaxFields.prototype, "Oktmo", {
        get: function () {
            if (this._oktmo == null) {
                this._oktmo = new ObasSprTableField(TableCollection.OktmoSprTable, this.Source);
            }
            return this._oktmo;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TaxFields.prototype, "Subject", {
        get: function () {
            if (this._subject == null) {
                this._subject = new ObasSprTableField(TableCollection.SubjectsSprTable, this.Source);
            }
            return this._subject;
        },
        enumerable: true,
        configurable: true
    });
    TaxFields.prototype.GenerateNode = function (nodeId, isRequired, maxOccurs) {
        var result = _super.prototype.GenerateNode.call(this, nodeId, isRequired, maxOccurs);
        result.AddChildNode(this.PostCode.GenerateNode());
        result.AddChildNode(this.Subject.GenerateNode());
        result.AddChildNode(this.DistrictName.GenerateNode());
        result.AddChildNode(this.Oktmo.GenerateNode());
        return result;
    };
    return TaxFields;
}(AddressFields));
var OrgFields = (function (_super) {
    __extends(OrgFields, _super);
    function OrgFields(source) {
        var _this = _super.call(this, source) || this;
        _this._fullName = new ObasTableField("FullName", _this.Source);
        _this._kpp = new ObasTableField("Kpp", _this.Source);
        return _this;
    }
    Object.defineProperty(OrgFields.prototype, "FullName", {
        get: function () {
            return this._fullName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrgFields.prototype, "Kpp", {
        get: function () {
            return this._kpp;
        },
        enumerable: true,
        configurable: true
    });
    OrgFields.prototype.GenerateNode = function (nodeId, isRequired, maxOccurs) {
        var result = _super.prototype.GenerateNode.call(this, nodeId, isRequired, maxOccurs);
        result.AddChildNode(this.FullName.GenerateNode());
        result.AddChildNode(this.Kpp.GenerateNode());
        return result;
    };
    return OrgFields;
}(TaxFields));
var EmployeeFields = (function () {
    function EmployeeFields(source, prefix, postfix) {
        this._exportNode = null;
        this._prefix = prefix || "";
        this._postfix = postfix || "";
        this._source = source;
        this._recordKey = new NumberObasTableField(this._prefix + "Workers" + this._postfix + "_ID", this._source);
        this._fullName = new ObasTableField(this._prefix + "FullName" + this._postfix, this._source);
        this._post = new ObasTableField(this._prefix + "Post" + this._postfix, this._source);
    }
    Object.defineProperty(EmployeeFields.prototype, "RecordKey", {
        get: function () {
            return this._recordKey;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EmployeeFields.prototype, "FullName", {
        get: function () {
            return this._fullName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EmployeeFields.prototype, "Post", {
        get: function () {
            return this._post;
        },
        enumerable: true,
        configurable: true
    });
    EmployeeFields.prototype.GenerateNode = function (nodeId, description, isRequired, maxOccurs) {
        if (description === void 0) { description = "Подписант"; }
        this._exportNode = new ComplexNodeXmlElementInfo(nodeId || this._prefix + "Employee", description, isRequired, maxOccurs);
        this._exportNode.AddChildNode(this._fullName.GenerateNode("FullName"));
        this._exportNode.AddChildNode(this._post.GenerateNode("Post"));
        return this._exportNode;
    };
    EmployeeFields.prototype.ExportTemplate = function (nodeId) {
        return ObasHelper.GenerateExportTemplate(this.GenerateNode(nodeId));
    };
    return EmployeeFields;
}());
var FioFields = (function () {
    function FioFields(source, prefix, postfix) {
        this._exportNode = null;
        this._prefix = prefix || "";
        this._postfix = postfix || "";
        this._source = source;
        this._firstName = new ObasTableField(this._prefix + "FirstName" + this._postfix, this._source);
        this._lastName = new ObasTableField(this._prefix + "LastName" + this._postfix, this._source);
        this._middleName = new ObasTableField(this._prefix + "MiddleName" + this._postfix, this._source);
        this._fullName = new ObasTableField(this._prefix + "FullName" + this._postfix, this._source);
        this._shortName = new ObasTableField(this._prefix + "ShortName" + this._postfix, this._source);
    }
    Object.defineProperty(FioFields.prototype, "FirstName", {
        get: function () {
            return this._firstName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FioFields.prototype, "LastName", {
        get: function () {
            return this._lastName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FioFields.prototype, "MiddleName", {
        get: function () {
            return this._middleName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FioFields.prototype, "Source", {
        get: function () {
            return this._source;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FioFields.prototype, "FullName", {
        get: function () {
            var result = ObasHelper.ConvertToString(this.LastName.Value);
            var tmpName = this.FirstName.Value;
            if (tmpName) {
                result += " " + tmpName;
            }
            tmpName = this.MiddleName.Value;
            if (tmpName) {
                result += " " + tmpName;
            }
            return result;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FioFields.prototype, "ShortName", {
        get: function () {
            var shortName = ObasHelper.ConvertToString(this.LastName.Value);
            var tmpPart = ObasHelper.ConvertToString(this.FirstName.Value);
            if (tmpPart.length > 0) {
                shortName += " " + tmpPart.substr(0, 1) + ".";
            }
            tmpPart = ObasHelper.ConvertToString(this.MiddleName.Value);
            if (tmpPart.length > 0) {
                shortName += " " + tmpPart.substr(0, 1) + ".";
            }
            return shortName;
        },
        enumerable: true,
        configurable: true
    });
    FioFields.prototype.GenerateNode = function (nodeId, description, isRequired, maxOccurs) {
        if (description === void 0) { description = "ФИО"; }
        this._exportNode = new ComplexNodeXmlElementInfo(nodeId || "Fio" + this._postfix, description, isRequired, maxOccurs);
        this._exportNode.AddChildNode(this._lastName.GenerateNode("Last"));
        this._exportNode.AddChildNode(this._firstName.GenerateNode("First"));
        this._exportNode.AddChildNode(this._middleName.GenerateNode("Middle"));
        return this._exportNode;
    };
    FioFields.prototype.ExportTemplate = function () {
        return ObasHelper.GenerateExportTemplate(this.GenerateNode());
    };
    FioFields.prototype.UpdateFio = function () {
        this._fullName.Value = this.FullName;
        this._shortName.Value = this.ShortName;
    };
    return FioFields;
}());
var PersonTable = (function (_super) {
    __extends(PersonTable, _super);
    function PersonTable(tableId, nodeId) {
        var _this = _super.call(this, tableId, nodeId) || this;
        _this._fioFields = null;
        _this._taxInfo = null;
        _this._taxRegDate = new ObasTableField("TaxRegDate", _this);
        return _this;
    }
    Object.defineProperty(PersonTable.prototype, "TaxFields", {
        get: function () {
            if (this._taxInfo == null) {
                this._taxInfo = new TaxFields(this);
            }
            return this._taxInfo;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PersonTable.prototype, "FioFields", {
        get: function () {
            if (this._fioFields == null) {
                this._fioFields = new FioFields(this);
            }
            return this._fioFields;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PersonTable.prototype, "TaxRegDate", {
        get: function () {
            return this._taxRegDate;
        },
        enumerable: true,
        configurable: true
    });
    PersonTable.prototype.GenerateBody = function () {
        var result = [];
        result.push(this.FioFields.GenerateNode());
        result.push(this.TaxRegDate.GenerateNode());
        result = result.concat(this.TaxFields.GenerateNode().Childs);
        return result;
    };
    PersonTable.prototype.GetFullName = function () {
        return this.FioFields.FullName;
    };
    PersonTable.prototype.FioChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
        this.FioFields.UpdateFio();
    };
    PersonTable.prototype.GetLocateFields = function () {
        return [this.StartDate.Id, this.TaxFields.Inn.Id, this.TaxFields.Oktmo.ForeignKey.Id];
    };
    PersonTable.prototype.TaxRegDateCheckEventHandler = function (tableId, fieldId) {
        return this.CurrentDateFieldCheck(this.TaxRegDate);
    };
    return PersonTable;
}(BaseVersionEntityTable));
