﻿var InterfaceRulesFMain = (function () {
    function InterfaceRulesFMain(document) {
        this._document = document;
    }
    InterfaceRulesFMain.prototype.ExportXsdMenuItemClickEventHandler = function () {
        this._document.InfoSheet.ExportToXsd();
    };
    InterfaceRulesFMain.prototype.ExportRequestXsdMenuItemClickEventHandler = function () {
        this._document.RequestSheet.ExportToXsd();
    };
    InterfaceRulesFMain.prototype.InfoArchMenuItemClickEventHandler = function () {
        this._document.ArchInfoSheet.ContainerEditor.Show();
    };
    InterfaceRulesFMain.prototype.RequestArchMenuItemClickEventHandler = function () {
        this._document.ArchRequestSheet.ContainerEditor.Show();
    };
    InterfaceRulesFMain.prototype.GetRegistryFileName = function () {
        return "Реестр банковских гарантий";
    };
    InterfaceRulesFMain.prototype.GetRegistryTemplateFilePath = function () {
        return "xls\\Registry.xls";
    };
    InterfaceRulesFMain.prototype.UpdateFormMenuItemClickEventHandler = function () {
        var fileToUpdate = Client.SelectFile("Выберите файл для обновления", "*.xml");
        if (fileToUpdate != null) {
            var templateFile = Client.SelectFile("Выберите шаблон обновления", "*.xml");
            if (templateFile != null) {
                Client.UpdateDocument(templateFile, fileToUpdate);
                Client.ShowMessage("Информация", "Обновление завершено", MessageIcons.Information);
            }
        }
    };
    InterfaceRulesFMain.prototype.AfterStartEventHandler = function () {
        switch (this._document.AssemblyType) {
            case AssemblyTypes.Full:
                if (TableCollection.BankTable.RowCount === 0) {
                    this._document.BankContainer.Editor.Show(EditorShowMode.Create);
                }
                break;
            case AssemblyTypes.OnlyRequest:
                if (TableCollection.DeclarerTable.RowCount === 0) {
                    this._document.DeclarerContainer.Editor.Show(EditorShowMode.Create);
                }
                break;
        }
    };
    InterfaceRulesFMain.prototype.IsFullAssembly = function () {
        return this._document.AssemblyType === AssemblyTypes.Full;
    };
    InterfaceRulesFMain.prototype.IsShortAssembly = function () {
        return this._document.AssemblyType === AssemblyTypes.OnlyRequest;
    };
    InterfaceRulesFMain.prototype.StartEventHandler = function () {
        Client.SetComponentText(ClientComponents.lblFoiv, "Поддержка: 8 (800) 333-62-26 E-mail: support.zrbg@minfin.ru");
    };
    InterfaceRulesFMain.prototype.GetProgramDescriptionEventHandler = function () {
        return this.IsFullAssembly()
            ? "Модуль формирования информации о выданных банковских гарантиях (ее изменении) и формирования запросов о предоставлении выписки из закрытого реестра банковских гарантий подготовлен в соответствии с требованиями, установленными приказом Министерства финансов Российской Федерации от 22 октября 2015 г. № 164н «О порядке формирования и направления информации в целях формирования и ведения закрытого реестра банковских гарантий, а также направления федеральным казначейством выписок и протоколов»"
            : "Модуль формирования запросов о предоставлении выписки из закрытого реестра банковских гарантий подготовлен в соответствии с требованиями, установленными приказом Министерства финансов Российской Федерации от 22 октября 2015 г. № 164н «О порядке формирования и направления информации в целях формирования и ведения закрытого реестра банковских гарантий, а также направления федеральным казначейством выписок и протоколов»";
    };
    InterfaceRulesFMain.prototype.PlanningStructureTypesSprMenuItemClickEventHandler = function () {
        this._document.ShowEditor("PlanningStructureTypesSpr");
    };
    InterfaceRulesFMain.prototype.RoadNetworkTypesSprMenuItemClickEventHandler = function () {
        this._document.ShowEditor("RoadNetworkTypesSpr");
    };
    InterfaceRulesFMain.prototype.AddressTypesSprMenuItemClickEventHandler = function () {
        this._document.ShowEditor("AddressTypesSpr");
    };
    InterfaceRulesFMain.prototype.OKTMOSprMenuItemClickEventHandler = function () {
        this._document.ShowEditor("OKTMOSpr");
    };
    InterfaceRulesFMain.prototype.OKTMOSprImportDtaMenuItemClickEventHandler = function () {
        TableCollection.OktmoSprTable.OktmoSprTableImportDataMenuItemClickEventHandler();
//        this._document.ShowEditor("OKTMOSpr");
    };
    InterfaceRulesFMain.prototype.BankWorkersSprMenuItemClickEventHandler = function () {
        this._document.ShowEditor("BankWorkersSpr");
    };
    InterfaceRulesFMain.prototype.FTWorkersSprMenuItemClickEventHandler = function () {
        this._document.ShowEditor("FTWorkersSpr");
    };
    InterfaceRulesFMain.prototype.StatementWorkersSprMenuItemClickEventHandler = function () {
        this._document.ShowEditor("StatementWorkersSpr");
    };
    InterfaceRulesFMain.prototype.DeclarerWorkersSprMenuItemClickEventHandler = function () {
        this._document.ShowEditor("DeclarerWorkersSpr");
    };
    InterfaceRulesFMain.prototype.BankDetailsShortSprMenuItemClickEventHandler = function () {
        this._document.ShowEditor("BankDetailsShortSpr");
    };
    InterfaceRulesFMain.prototype.LegalEntityProviderShortSprMenuItemClickEventHandler = function () {
        this._document.ShowEditor("LegalEntityProviderShortSpr");
    };
    InterfaceRulesFMain.prototype.IndividualBusinessmanProviderShortSprMenuItemClickEventHandler = function () {
        this._document.ShowEditor("IndividualBusinessmanProviderShortSpr");
    };
    InterfaceRulesFMain.prototype.ForeignCitizenProviderShortSprMenuItemClickEventHandler = function () {
        this._document.ShowEditor("ForeignCitizenProviderShortSpr");
    };
    InterfaceRulesFMain.prototype.ForeignLegalEntityProviderShortSprMenuItemClickEventHandler = function () {
        this._document.ShowEditor("ForeignLegalEntityProviderShortSpr");
    };
    InterfaceRulesFMain.prototype.CustomerDetailsShortSprMenuItemClickEventHandler = function () {
        this._document.ShowEditor("CustomerDetailsShortSpr");
    };
    return InterfaceRulesFMain;
}());
