﻿var UpdateRulesFMain = (function () {
    function UpdateRulesFMain(document) {
        this._document = document;
    }
    UpdateRulesFMain.prototype.UpdateTemplate = function (oldVersion, currentVersion) {
        if (oldVersion < "1.2.2") {
            this.UpdateDspLink();
        }
        if (oldVersion < "1.2.4") {
            this.UpdateRequestDisplaySum();
            this.UpdateFtMessageVers(this._document.BankGuaranteesTable);
            this.UpdateFtMessageVers(this._document.BankGuaranteesRequestTable);
        }
        if (oldVersion < "1.3.0") {
            this.UpdateArchivedFlag(this._document.BankGuaranteesTable);
            this.UpdateArchivedFlag(this._document.BankGuaranteesRequestTable);
        }
        if (oldVersion < "1.3.10") {
            this.UpdateRequestDisplaySum();
        }
    };
    UpdateRulesFMain.prototype.UpdateArchivedFlag = function (source) {
        var reader = source.CreateReader();
        while (reader.Read()) {
            source.IsArched = false;
        }
    };
    UpdateRulesFMain.prototype.UpdateRequestDisplaySum = function () {
        var requestTable = this._document.BankGuaranteesRequestTable;
        var reader = requestTable.CreateReader();
        while (reader.Read()) {
            requestTable.UsdValueChangeEventHandler(requestTable.Id, null, null, requestTable.UsdValue.Id);
        }
    };
    UpdateRulesFMain.prototype.UpdateFtMessageVers = function (source) {
        var reader = source.CreateReader();
        while (reader.Read()) {
            source.FtMessageVerField.Value = source.FtMessageVersionInitEventHandler(source.Id);
            source.FtMessageCanExport.Value = true;
        }
    };
    UpdateRulesFMain.prototype.UpdateDspLink = function () {
        var changedInfNums = this.DeleteDspLink(this._document.BankGuaranteesTable);
        var changedReqNums = this.DeleteDspLink(this._document.BankGuaranteesRequestTable);
        if (changedInfNums.length || changedReqNums.length) {
            var messageParts = [];
            if (changedInfNums.length) {
                messageParts.push("Записи с № информации:");
                messageParts.push(changedInfNums.join(", "));
            }
            if (changedReqNums.length) {
                messageParts.push("Записи с № запросов:");
                messageParts.push(changedReqNums.join(", "));
            }
            messageParts.push("С грифом секретности ДСП");
            messageParts.push("Согласно документу:");
            messageParts.push("Письмо Федерального казначейства от 17.03.2016 №07-04-05/03-180\nо разъяснении положений Приказа Министерства финансов российской Федерации от 22.10.2015 № 164н\n\"О порядке формирования и направления информации в целях формирования и ведения закрытого реестра банковских гарантий,\nа также направления Федеральным казначейством выписок и протоколов\"");
            messageParts.push("не подлежат включению в закрытый реестр банковских гарантий");
            Client.ShowMessage("Уведомление", messageParts.join("\n"), MessageIcons.Information);
        }
    };
    UpdateRulesFMain.prototype.DeleteDspLink = function (scrTable) {
        var secTypeField = scrTable.SecurityType.ForeignKey;
        var changedNums = [];
        while (scrTable.Locate(secTypeField.Id, SecurityTypes.Confidential, true)) {
            secTypeField.Value = null;
            changedNums.push(scrTable.RowNumber.Value);
        }
        scrTable.ClearLocateFlag();
        return changedNums;
    };
    return UpdateRulesFMain;
}());
