﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var BaseTaxOrganizationTable = (function (_super) {
    __extends(BaseTaxOrganizationTable, _super);
    function BaseTaxOrganizationTable(tableId, nodeId) {
        var _this = _super.call(this, tableId, nodeId) || this;
        _this._orgFields = null;
        _this._taxRegDate = new ObasTableField("TaxRegDate", _this);
        return _this;
    }
    Object.defineProperty(BaseTaxOrganizationTable.prototype, "OrgFields", {
        get: function () {
            if (this._orgFields == null) {
                this._orgFields = new OrgFields(this);
            }
            return this._orgFields;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseTaxOrganizationTable.prototype, "TaxRegDate", {
        get: function () {
            return this._taxRegDate;
        },
        enumerable: true,
        configurable: true
    });
    BaseTaxOrganizationTable.prototype.GenerateBody = function () {
        var result = [];
        result.push(this.TaxRegDate.GenerateNode());
        result = result.concat(this.OrgFields.GenerateNode().Childs);
        return result;
    };
    BaseTaxOrganizationTable.prototype.GetLocateFields = function () {
        return [this.StartDate.Id, this.OrgFields.Inn.Id, this.OrgFields.Oktmo.ForeignKey.Id];
    };
    BaseTaxOrganizationTable.prototype.TaxRegDateCheckEventHandler = function (tableId, fieldId) {
        return this.CurrentDateFieldCheck(this.TaxRegDate);
    };
    return BaseTaxOrganizationTable;
}(BaseVersionEntityTable));
var BaseOrganizationTable = (function (_super) {
    __extends(BaseOrganizationTable, _super);
    function BaseOrganizationTable(tableId, nodeId) {
        var _this = _super.call(this, tableId, nodeId) || this;
        _this._shortName = new ObasTableField("ShortName", _this);
        return _this;
    }
    Object.defineProperty(BaseOrganizationTable.prototype, "ShortName", {
        get: function () {
            return this._shortName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseOrganizationTable.prototype, "TaxFields", {
        get: function () {
            return this.OrgFields;
        },
        enumerable: true,
        configurable: true
    });
    BaseOrganizationTable.prototype.GenerateBody = function () {
        var result = _super.prototype.GenerateBody.call(this);
        result.push(this.ShortName.GenerateNode());
        return result;
    };
    return BaseOrganizationTable;
}(BaseTaxOrganizationTable));
var LegalEntityTable = (function (_super) {
    __extends(LegalEntityTable, _super);
    function LegalEntityTable(tableId, nodeId) {
        var _this = _super.call(this, tableId, nodeId) || this;
        _this._okopf = null;
        return _this;
    }
    Object.defineProperty(LegalEntityTable.prototype, "Okopf", {
        get: function () {
            if (this._okopf == null) {
                this._okopf = new ObasSprTableField(TableCollection.OkopfSprTable, this);
            }
            return this._okopf;
        },
        enumerable: true,
        configurable: true
    });
    LegalEntityTable.prototype.GenerateBody = function () {
        var result = _super.prototype.GenerateBody.call(this);
        result.push(this.Okopf.GenerateNode());
        return result;
    };
    LegalEntityTable.prototype.GetFullName = function () {
        return this.OrgFields.FullName.Value;
    };
    return LegalEntityTable;
}(BaseOrganizationTable));
var OrganizationTable = (function (_super) {
    __extends(OrganizationTable, _super);
    function OrganizationTable(id, postfix) {
        var _this = _super.call(this, id + "Details" + (postfix || ""), "" + id + (postfix || "")) || this;
        _this._code = new ObasTableField("Code", _this);
        return _this;
    }
    Object.defineProperty(OrganizationTable.prototype, "Code", {
        get: function () {
            return this._code;
        },
        enumerable: true,
        configurable: true
    });
    OrganizationTable.prototype.GenerateBody = function () {
        var result = _super.prototype.GenerateBody.call(this);
        result.push(this.Code.GenerateNode());
        return result;
    };
    return OrganizationTable;
}(LegalEntityTable));
