﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var BankTable = (function (_super) {
    __extends(BankTable, _super);
    function BankTable(id, postfix) {
        var _this = _super.call(this, id, postfix) || this;
        _this.IsRequestMode = false;
        return _this;
    }
    BankTable.prototype.GenerateBody = function () {
        var result = _super.prototype.GenerateBody.call(this);
        if (this.IsRequestMode) {
            var exceptElems_1 = [this.Code.Id, this.ShortName.Id, this.Okopf.Id];
            return result.filter(function (val) {
                return exceptElems_1.indexOf(val.Name) === -1;
            });
        }
        return result;
    };
    return BankTable;
}(OrganizationTable));
var CustomerTable = (function (_super) {
    __extends(CustomerTable, _super);
    function CustomerTable(id, postfix) {
        return _super.call(this, id, postfix) || this;
    }
    return CustomerTable;
}(OrganizationTable));
var DeclarerTable = (function (_super) {
    __extends(DeclarerTable, _super);
    function DeclarerTable() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DeclarerTable.prototype.InnCheckEventHandler = function (tableId, fieldId) {
        if (!DeclarerTable._checkInnRegExp.test(this.OrgFields.Inn.Value)) {
            return "Длина вводимого значения должна составлять 10 или 12 знаков и состоять из цифр";
        }
        return undefined;
    };
    return DeclarerTable;
}(BaseTaxOrganizationTable));
DeclarerTable._checkInnRegExp = /^\d{10}$|^\d{12}$/;
var ForeignPersonTable = (function (_super) {
    __extends(ForeignPersonTable, _super);
    function ForeignPersonTable(id) {
        var _this = _super.call(this, id) || this;
        _this._fioEngFields = null;
        _this._foreignData = null;
        return _this;
    }
    Object.defineProperty(ForeignPersonTable.prototype, "FioEngFields", {
        get: function () {
            if (this._fioEngFields == null) {
                this._fioEngFields = new FioFields(this, null, "Latin");
            }
            return this._fioEngFields;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ForeignPersonTable.prototype, "ForeignData", {
        get: function () {
            if (this._foreignData == null) {
                this._foreignData = new ForeignFields(this);
            }
            return this._foreignData;
        },
        enumerable: true,
        configurable: true
    });
    ForeignPersonTable.prototype.GenerateBody = function () {
        var result = _super.prototype.GenerateBody.call(this);
        result.push(this.FioEngFields.GenerateNode());
        result = result.concat(this.ForeignData.GenerateNode().Childs);
        return result;
    };
    return ForeignPersonTable;
}(PersonTable));
var ForeignLegalEntityTable = (function (_super) {
    __extends(ForeignLegalEntityTable, _super);
    function ForeignLegalEntityTable(id) {
        var _this = _super.call(this, id) || this;
        _this._foreignData = null;
        _this._corpName = new ObasTableField("CorporateName", _this);
        _this._fullNameEng = new ObasTableField("FullNameLatin", _this);
        _this._shortNameEng = new ObasTableField("ShortNameLatin", _this);
        _this._corpNameEng = new ObasTableField("CorporateNameLatin", _this);
        return _this;
    }
    Object.defineProperty(ForeignLegalEntityTable.prototype, "CorpName", {
        get: function () {
            return this._corpName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ForeignLegalEntityTable.prototype, "FullNameEng", {
        get: function () {
            return this._fullNameEng;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ForeignLegalEntityTable.prototype, "ShortNameEng", {
        get: function () {
            return this._shortNameEng;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ForeignLegalEntityTable.prototype, "CorpNameEng", {
        get: function () {
            return this._corpNameEng;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ForeignLegalEntityTable.prototype, "ForeignData", {
        get: function () {
            if (this._foreignData == null) {
                this._foreignData = new ForeignFields(this);
            }
            return this._foreignData;
        },
        enumerable: true,
        configurable: true
    });
    ForeignLegalEntityTable.prototype.GetFullName = function () {
        return this.OrgFields.FullName.Value;
    };
    ForeignLegalEntityTable.prototype.GenerateBody = function () {
        var result = _super.prototype.GenerateBody.call(this);
        result.push(this.CorpName.GenerateNode());
        result.push(this.FullNameEng.GenerateNode());
        result.push(this.ShortNameEng.GenerateNode());
        result.push(this.CorpNameEng.GenerateNode());
        result = result.concat(this.ForeignData.GenerateNode().Childs);
        return result;
    };
    return ForeignLegalEntityTable;
}(BaseOrganizationTable));
var TofkTable = (function (_super) {
    __extends(TofkTable, _super);
    function TofkTable(id) {
        var _this = _super.call(this, id, "TOFK") || this;
        _this._orgFields = null;
        _this.IsRequestMode = false;
        _this._code = new ObasTableField("Code", _this);
        return _this;
    }
    Object.defineProperty(TofkTable.prototype, "Code", {
        get: function () {
            return this._code;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TofkTable.prototype, "OrgFields", {
        get: function () {
            if (this._orgFields == null) {
                this._orgFields = new OrgFields(this);
            }
            return this._orgFields;
        },
        enumerable: true,
        configurable: true
    });
    TofkTable.prototype.GenerateBody = function () {
        var result = this.OrgFields.GenerateNode().Childs;
        result.push(this.Code.GenerateNode());
        if (this.IsRequestMode) {
            var exceptElems_2 = [this.Code.Id, this.OrgFields.Inn.Id, this.OrgFields.Kpp.Id];
            return result.filter(function (val) {
                return exceptElems_2.indexOf(val.Name) === -1;
            });
        }
        return result;
    };
    TofkTable.prototype.GetLocateFields = function () {
        return [this.StartDate.Id, this.OrgFields.Inn.Id, this.OrgFields.Oktmo.ForeignKey.Id];
    };
    return TofkTable;
}(BaseVersionEntityTable));
var PersonShortTable = (function (_super) {
    __extends(PersonShortTable, _super);
    function PersonShortTable() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PersonShortTable.prototype.GenerateBody = function () {
        var result = [];
        result.push(this.FioFields.GenerateNode());
        result.push(this.TaxFields.Inn.GenerateNode());
        return result;
    };
    return PersonShortTable;
}(PersonTable));
var ForeignPersonShortTable = (function (_super) {
    __extends(ForeignPersonShortTable, _super);
    function ForeignPersonShortTable() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ForeignPersonShortTable.prototype.GenerateBody = function () {
        var result = [];
        result.push(this.FioFields.GenerateNode());
        result.push(this.FioEngFields.GenerateNode());
        result.push(this.ForeignData.Inn.GenerateNode());
        result.push(this.TaxFields.Inn.GenerateNode());
        return result;
    };
    return ForeignPersonShortTable;
}(ForeignPersonTable));
var BankShortTable = (function (_super) {
    __extends(BankShortTable, _super);
    function BankShortTable() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BankShortTable.prototype.GenerateBody = function () {
        var result = [];
        result.push(this.OrgFields.FullName.GenerateNode());
        result.push(this.OrgFields.Inn.GenerateNode());
        result.push(this.OrgFields.Kpp.GenerateNode());
        return result;
    };
    return BankShortTable;
}(BankTable));
var CustomerShortTable = (function (_super) {
    __extends(CustomerShortTable, _super);
    function CustomerShortTable() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CustomerShortTable.prototype.GenerateBody = function () {
        var result = [];
        result.push(this.OrgFields.FullName.GenerateNode());
        result.push(this.ShortName.GenerateNode());
        result.push(this.OrgFields.Inn.GenerateNode());
        result.push(this.OrgFields.Kpp.GenerateNode());
        return result;
    };
    return CustomerShortTable;
}(CustomerTable));
var LegalEntityShortTable = (function (_super) {
    __extends(LegalEntityShortTable, _super);
    function LegalEntityShortTable() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LegalEntityShortTable.prototype.GenerateBody = function () {
        var result = [];
        result.push(this.OrgFields.FullName.GenerateNode());
        result.push(this.OrgFields.Inn.GenerateNode());
        result.push(this.OrgFields.Kpp.GenerateNode());
        return result;
    };
    return LegalEntityShortTable;
}(LegalEntityTable));
var ForeignLegalEntityShortTable = (function (_super) {
    __extends(ForeignLegalEntityShortTable, _super);
    function ForeignLegalEntityShortTable() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ForeignLegalEntityShortTable.prototype.GenerateBody = function () {
        var result = [];
        result.push(this.OrgFields.FullName.GenerateNode());
        result.push(this.FullNameEng.GenerateNode());
        result.push(this.ForeignData.Inn.GenerateNode());
        result.push(this.OrgFields.Inn.GenerateNode());
        result.push(this.OrgFields.Kpp.GenerateNode());
        return result;
    };
    return ForeignLegalEntityShortTable;
}(ForeignLegalEntityTable));
