﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var BaseRegistrySheet = (function () {
    function BaseRegistrySheet(id, editor) {
        this._sourceTable = editor.SourceTable;
        this._editor = editor;
        this._document = editor.Document;
        this._id = id;
    }
    Object.defineProperty(BaseRegistrySheet.prototype, "SystemSheet", {
        get: function () {
            if (this._systemSheet == null) {
                this._systemSheet = this.GetSheetsContainer().getValue(this.Id + "Sheet");
            }
            return this._systemSheet;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseRegistrySheet.prototype, "SourceTable", {
        get: function () {
            return this._sourceTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseRegistrySheet.prototype, "Id", {
        get: function () {
            return this._id;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseRegistrySheet.prototype, "Document", {
        get: function () {
            return this._document;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseRegistrySheet.prototype, "SourceKey", {
        get: function () {
            return this.SystemSheet.Table.GetKeyBySourceTable(this._sourceTable);
        },
        enumerable: true,
        configurable: true
    });
    BaseRegistrySheet.prototype.ExportToFt = function (source, recordKey, isXsd) {
        if (isXsd === void 0) { isXsd = false; }
        if (isXsd) {
            ObasHelper.IsGenerateToXsd = true;
            var xmlContent = source.CreateExportTemplate(recordKey);
            ObasHelper.IsGenerateToXsd = false;
            var fileName = ObasHelper.GetFtExportFolder() + source.GetExportName() + ".xsd";
            if (Client.SetFileData(fileName, "<?xml version=\"1.0\" encoding=\"utf-8\"?><xs:schema attributeFormDefault=\"unqualified\" elementFormDefault=\"qualified\" xmlns:xs=\"http://www.w3.org/2001/XMLSchema\">" + xmlContent + "</xs:schema>")) {
                Client.ShowMessage("Формирование XSD", "XSD схема сгенерирована:\n" + fileName);
            }
        }
        else {
            var xmlContent = source.CreateExportTemplate(recordKey);
            var fileName = ObasHelper.GetFtExportFolder() + source.GetExportName() + ".xml";
            if (Client.SetFileData(fileName, "<?xml version=\"1.0\" encoding=\"utf-8\"?>" + xmlContent)) {
                Client.ShowMessage("Выгрузка в ФК", "Запись реестра успешно выгружена:\n" + fileName);
            }
        }
    };
    BaseRegistrySheet.prototype.RegistryMenuItemShowEventHandler = function () {
        return this.SourceKey != null;
    };
    BaseRegistrySheet.prototype.ExportToFtMenuItemClickEventHandler = function () {
        this.ExportToFt(this._sourceTable, this.SourceKey);
    };
    BaseRegistrySheet.prototype.ExportToXsd = function () {
        this.ExportToFt(this._sourceTable, null, true);
    };
    BaseRegistrySheet.prototype.ExportToFtMenuItemShowEventHandler = function () {
        var key = this.SourceKey;
        if (key != null) {
            this._sourceTable.LocateByKeys(key);
            return this._sourceTable.StatusField.ForeignKey.Value > ObasHelper.DraftStatusKey &&
                this._sourceTable.FtMessageCanExport.Value;
        }
        return false;
    };
    BaseRegistrySheet.prototype.ExportToExcelMenuItemClickEventHandler = function () {
        this._sourceTable.ExportToExcel(this.SourceKey);
    };
    BaseRegistrySheet.prototype.PreviewMenuItemClickEventHandler = function () {
        var sourceTable = this._editor.SourceTable;
        sourceTable.LocateByKeys(this.SourceKey);
        this._editor.Show(EditorShowMode.Preview);
    };
    BaseRegistrySheet.prototype.DeleteMenuItemClickEventHandler = function () {
        if (this._sourceTable.LocateByKeys(this.SourceKey) &&
            this._document.ShowEditor(this._id + "DelEditor")) {
            this.SourceTable.IsArched = true;
        }
    };
    return BaseRegistrySheet;
}());
var RegisrtySheet = (function (_super) {
    __extends(RegisrtySheet, _super);
    function RegisrtySheet() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RegisrtySheet.prototype.RegistryLoadEventHandler = function (tableId) {
        return !this.SourceTable.IsArched;
    };
    RegisrtySheet.prototype.GetSheetsContainer = function () {
        return this.Document.Sheets;
    };
    return RegisrtySheet;
}(BaseRegistrySheet));
var ArchRegisrtySheet = (function (_super) {
    __extends(ArchRegisrtySheet, _super);
    function ArchRegisrtySheet() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ArchRegisrtySheet.prototype.RegistryLoadEventHandler = function (tableId) {
        return this.SourceTable.IsArched;
    };
    Object.defineProperty(ArchRegisrtySheet.prototype, "ContainerEditor", {
        get: function () {
            if (this._containerEditor == null) {
                this._containerEditor = this.Document.Editors.getValue(this.Id + "Editor");
            }
            return this._containerEditor;
        },
        enumerable: true,
        configurable: true
    });
    ArchRegisrtySheet.prototype.GetSheetsContainer = function () {
        return this.ContainerEditor.Sheets;
    };
    ArchRegisrtySheet.prototype.CopyMenuItemClickEventHandler = function () {
        this.SourceTable.CreateCopy(this.SourceKey);
    };
    return ArchRegisrtySheet;
}(BaseRegistrySheet));
var InfoRegisrtySheet = (function (_super) {
    __extends(InfoRegisrtySheet, _super);
    function InfoRegisrtySheet() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    InfoRegisrtySheet.prototype.AddVersionMenuItemClickEventHandler = function () {
        this.SourceTable.CreateNewVersion(this.SourceKey);
    };
    InfoRegisrtySheet.prototype.AddVersionMenuItemShowEventHandler = function () {
        var key = this.SourceKey;
        if (key != null) {
            this.SourceTable.LocateByKeys(key);
            return this.SourceTable.Status === DataStatuses.Included;
        }
        return false;
    };
    InfoRegisrtySheet.prototype.ShowEventHandler = function () {
        return this.Document.AssemblyType === AssemblyTypes.Full;
    };
    InfoRegisrtySheet.prototype.CanAddEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
        return TableCollection.BankTable.RowCount > 0;
    };
    return InfoRegisrtySheet;
}(RegisrtySheet));
