﻿var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var OksmSprTable = (function (_super) {
    __extends(OksmSprTable, _super);
    function OksmSprTable() {
        return _super.call(this, "OKSM") || this;
    }
    OksmSprTable.GetRussiaKey = function () {
        return 10259803;
    };
    return OksmSprTable;
}(SprTable));
var OkopfSprTable = (function (_super) {
    __extends(OkopfSprTable, _super);
    function OkopfSprTable() {
        return _super.call(this, "OKOPF") || this;
    }
    return OkopfSprTable;
}(SprTable));


var OktmoSprTable = (function (_super) {
    __extends(OktmoSprTable, _super);
    function OktmoSprTable() {
        return _super.call(this, "OKTMO") || this;
    }
    OktmoSprTable.prototype.CodeCheckEventHandler = function (tableId, fieldId) {
        var data = this.Code.Value || "";
        if (!data.match(OktmoSprTable._checkReg)) {
            return "Длина вводимого значения должна составлять 8 или 11 цифр";
        }
        return undefined;
    };
    
    OktmoSprTable.prototype.OktmoSprTableImportDataMenuItemClickEventHandler = function () {
        var filePath = Client.SelectFile("Загрузить данные ОКТМО", "Данные ОКТМО (*.CSV*)");
        if (filePath && Client.IsFileExists(filePath)) {
            var count = 0;
            Client.SetCursorType(TypeCursor.crHourGlass);
            count = this.ImportData(Client.GetFileData(filePath));
            Client.SetCursorType(TypeCursor.crDefault);
            if (count > 0) {
                Client.ShowMessage("Информация", "\u0418\u0437 \u0444\u0430\u0439\u043B\u0430: " + filePath + "\n\u0423\u0441\u043F\u0435\u0448\u043D\u043E \u0437\u0430\u0433\u0440\u0443\u0436\u0435\u043D\u043E " + count + " \u0441\u0442\u0440\u043E\u043A", MessageIcons.Information);
                this.DoTableChange();
            }
            else {
                Client.ShowMessage("Внимание", "\u0412 \u0444\u0430\u0439\u043B\u0435: " + filePath + "\n\u0414\u0430\u043D\u043D\u044B\u0445 \u041E\u041A\u0422\u041C\u041E \u043D\u0435\u0442", MessageIcons.Warning);
            }
        }
        else {
            Client.ShowMessage("Внимание", "Файл с данными не выбран.\nЗагрузка отменена.", MessageIcons.Warning);
        }
    };
    OktmoSprTable.prototype.ImportData = function (expendSheduleData) {
        var CountIns = 0;
        var apElems = expendSheduleData.split("\n");
        for (var _i = 0, apElems_2 = apElems; _i < apElems_2.length; _i++) {
            var apElem = apElems_2[_i];
            if (apElem.length > 0) {
                var apElemParts = apElem.split(";");
                var _TER = apElemParts[0];
                var _KOD1 = apElemParts[1];
                var _KOD2 = apElemParts[2];
                var _KOD3 = apElemParts[3];
                var _S = "000";
                _TER = _S.substr(0, 2 - _TER.length) + _TER;
                _KOD1 = _S.substr(0, 3 - _KOD1.length) + _KOD1;
                _KOD2 = _S.substr(0, 3 - _KOD2.length) + _KOD2;
                if (_KOD3 == "0") {
                    _KOD3 = "";
                }
                var _fcode = _TER + _KOD1 + _KOD2 + _KOD3;
                var _fname = apElemParts[6];
//                if (this.LookupKeyByCode(_fcode) != null) {
//                }
//                else {
                    this.AddRow();
                    this.Code.Value = _fcode;
                    this.Name.Value = _fname;
                    this.PostRow();
                    CountIns = CountIns + 1;
//                }
            }
        }
        return CountIns;
    };
    
    return OktmoSprTable;
}(SprTable));
OktmoSprTable._checkReg = /(^\d{8}$|^\d{11}$)/g;

var SubjectsSprTable = (function (_super) {
    __extends(SubjectsSprTable, _super);
    function SubjectsSprTable() {
        return _super.call(this, "Territories") || this;
    }
    return SubjectsSprTable;
}(SprTable));
var OkvSprTable = (function (_super) {
    __extends(OkvSprTable, _super);
    function OkvSprTable() {
        return _super.call(this, "OKV") || this;
    }
    OkvSprTable.IsRuble = function (code) {
        return (OkvSprTable._rubCodes.indexOf(code) > -1);
    };
    return OkvSprTable;
}(SprTable));
OkvSprTable._rubCodes = ["810", "643"];
var PlanningStructureTypesSprTable = (function (_super) {
    __extends(PlanningStructureTypesSprTable, _super);
    function PlanningStructureTypesSprTable() {
        return _super.call(this, "PlanningStructureTypes", ["Key"], "ShortName", "Name") || this;
    }
    return PlanningStructureTypesSprTable;
}(SprTable));
var RoadNetworkTypesSprTable = (function (_super) {
    __extends(RoadNetworkTypesSprTable, _super);
    function RoadNetworkTypesSprTable() {
        return _super.call(this, "RoadNetworkTypes", ["Key"], "ShortName", "Name") || this;
    }
    return RoadNetworkTypesSprTable;
}(SprTable));
var AddressTypesSprTable = (function (_super) {
    __extends(AddressTypesSprTable, _super);
    function AddressTypesSprTable() {
        return _super.call(this, "AddressTypes", ["Key"], "ShortName", "Name") || this;
    }
    return AddressTypesSprTable;
}(SprTable));
var SecurityTypesSprTable = (function (_super) {
    __extends(SecurityTypesSprTable, _super);
    function SecurityTypesSprTable() {
        return _super.call(this, "SecurityTypes", ["Key"], "ShortName", "Name") || this;
    }
    return SecurityTypesSprTable;
}(SprTable));
var DataStatusesSprTable = (function (_super) {
    __extends(DataStatusesSprTable, _super);
    function DataStatusesSprTable() {
        return _super.call(this, "DataStatuses", ["Key"], "Key") || this;
    }
    DataStatusesSprTable.prototype.GetDraft = function () {
        return DataStatuses.Draft;
    };
    Object.defineProperty(DataStatusesSprTable.prototype, "Status", {
        get: function () {
            return this.RecordKey.Value || DataStatuses.Draft;
        },
        enumerable: true,
        configurable: true
    });
    return DataStatusesSprTable;
}(SprTable));
var RequestStatusesSprTable = (function (_super) {
    __extends(RequestStatusesSprTable, _super);
    function RequestStatusesSprTable() {
        return _super.call(this, "RequestStatuses", ["Key"], "Key") || this;
    }
    RequestStatusesSprTable.prototype.GetDraft = function () {
        return RequestStatuses.Draft;
    };
    Object.defineProperty(RequestStatusesSprTable.prototype, "Status", {
        get: function () {
            return this.RecordKey.Value || RequestStatuses.Draft;
        },
        enumerable: true,
        configurable: true
    });
    return RequestStatusesSprTable;
}(SprTable));
var ProviderTypesSprTable = (function (_super) {
    __extends(ProviderTypesSprTable, _super);
    function ProviderTypesSprTable() {
        return _super.call(this, "ProviderTypes", ["Key"], "Key") || this;
    }
    return ProviderTypesSprTable;
}(SprTable));
var DocumentTypesSprTable = (function (_super) {
    __extends(DocumentTypesSprTable, _super);
    function DocumentTypesSprTable() {
        return _super.call(this, "DocumentTypes", ["Key"], "Key") || this;
    }
    DocumentTypesSprTable.prototype.DefaultInitEventHandler = function (tableId, fieldId) {
        return DocumentTypes.Proxy;
    };
    return DocumentTypesSprTable;
}(SprTable));
var StatementTypesSprTable = (function (_super) {
    __extends(StatementTypesSprTable, _super);
    function StatementTypesSprTable() {
        return _super.call(this, "StatementTypes", ["Key"], "Key") || this;
    }
    return StatementTypesSprTable;
}(SprTable));
var GetInfoMethodsTypesSprTable = (function (_super) {
    __extends(GetInfoMethodsTypesSprTable, _super);
    function GetInfoMethodsTypesSprTable() {
        return _super.call(this, "GetInfoMethodsTypes", ["Key"], "Key") || this;
    }
    GetInfoMethodsTypesSprTable.prototype.IsValid = function () {
        return this.RecordKey.Value !== MethodTypes.Site;
    };
    return GetInfoMethodsTypesSprTable;
}(SprTable));
var SequenceTable = (function (_super) {
    __extends(SequenceTable, _super);
    function SequenceTable() {
        var _this = _super.call(this, "Sequence", ["TableId"]) || this;
        _this._tableId = new ObasTableField("TableId", _this);
        _this._usedKey = new ObasTableField("UsedKey", _this);
        return _this;
    }
    SequenceTable.prototype.GetNextKey = function (table) {
        if (!this.LocateByKeys(table.Id)) {
            this.AddRow();
            this._tableId.Value = table.Id;
            this.PostRow();
        }
        return ++this._usedKey.Value;
    };
    SequenceTable.prototype.GetCurrentKey = function (table) {
        return this._usedKey.LookupByKeys(table.Id);
    };
    SequenceTable.prototype.UsedKeyInitEventHandler = function (tableId) {
        return 0;
    };
    return SequenceTable;
}(ObasTable));

var PrintOptionsSprTable = (function (_super) {
    __extends(PrintOptionsSprTable, _super);
    function PrintOptionsSprTable() {
        var _this = _super.call(this, "PrintOptions") || this;
        _this._IsPrintSecrecy = new ObasTableField("IsPrintSecrecy", _this);
        _this._IsPrintItemSecrecy = new ObasTableField("IsPrintItemSecrecy", _this);
        _this._ItemSecrecy = new ObasTableField("ItemSecrecy", _this);
        return _this;
    }
    PrintOptionsSprTable.prototype.IsPrintSecrecyChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
        if (this._IsPrintSecrecy.Value == false) {
            this._IsPrintItemSecrecy.Value = false;
        }
    }
    PrintOptionsSprTable.prototype.TextSecrecy = function (Secrecy) {
        if (this._IsPrintSecrecy.Value) {
            if (this._IsPrintItemSecrecy.Value) {
                return (Secrecy + "              \n" + this._ItemSecrecy.Value);
            }
            else {
                return (Secrecy);
            }
        }
        return ("");
    };
    return PrintOptionsSprTable;
}(SprTable));


var TableCollection = (function () {
    function TableCollection() {
    }
    Object.defineProperty(TableCollection, "OksmSprTable", {
        get: function () {
            if (TableCollection._oksmSprTable == null) {
                TableCollection._oksmSprTable = new OksmSprTable();
            }
            return TableCollection._oksmSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "OkopfSprTable", {
        get: function () {
            if (TableCollection._okopfSprTable == null) {
                TableCollection._okopfSprTable = new OkopfSprTable();
            }
            return TableCollection._okopfSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "OktmoSprTable", {
        get: function () {
            if (TableCollection._oktmoSprTable == null) {
                TableCollection._oktmoSprTable = new OktmoSprTable();
            }
            return TableCollection._oktmoSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "OkvSprTable", {
        get: function () {
            if (TableCollection._okvSprTable == null) {
                TableCollection._okvSprTable = new OkvSprTable();
            }
            return TableCollection._okvSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "SubjectsSprTable", {
        get: function () {
            if (TableCollection._subjectsSprTable == null) {
                TableCollection._subjectsSprTable = new SubjectsSprTable();
            }
            return TableCollection._subjectsSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "DocumentTypesSprTable", {
        get: function () {
            if (TableCollection._documentTypesSprTable == null) {
                TableCollection._documentTypesSprTable = new DocumentTypesSprTable();
            }
            return TableCollection._documentTypesSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "ProviderTypesSprTable", {
        get: function () {
            if (TableCollection._providerTypesSprTable == null) {
                TableCollection._providerTypesSprTable = new ProviderTypesSprTable();
            }
            return TableCollection._providerTypesSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "PlanningStructureTypesSprTable", {
        get: function () {
            if (TableCollection._planningStructureTypesSprTable == null) {
                TableCollection._planningStructureTypesSprTable = new PlanningStructureTypesSprTable();
            }
            return TableCollection._planningStructureTypesSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "RoadNetworkTypesSprTable", {
        get: function () {
            if (TableCollection._roadNetworkTypesSprTable == null) {
                TableCollection._roadNetworkTypesSprTable = new RoadNetworkTypesSprTable();
            }
            return TableCollection._roadNetworkTypesSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "AddressTypesSprTable", {
        get: function () {
            if (TableCollection._addressTypesSprTable == null) {
                TableCollection._addressTypesSprTable = new AddressTypesSprTable();
            }
            return TableCollection._addressTypesSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "RequestStatusesSprTable", {
        get: function () {
            if (TableCollection._requestStatusesSprTable == null) {
                TableCollection._requestStatusesSprTable = new RequestStatusesSprTable();
            }
            return TableCollection._requestStatusesSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "DataStatusesSprTable", {
        get: function () {
            if (TableCollection._dataStatusesSprTable == null) {
                TableCollection._dataStatusesSprTable = new DataStatusesSprTable();
            }
            return TableCollection._dataStatusesSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "SecurityTypesSprTable", {
        get: function () {
            if (TableCollection._securityTypesSprTable == null) {
                TableCollection._securityTypesSprTable = new SecurityTypesSprTable();
            }
            return TableCollection._securityTypesSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "StatementTypesSprTable", {
        get: function () {
            if (TableCollection._statementTypesSprTable == null) {
                TableCollection._statementTypesSprTable = new StatementTypesSprTable();
            }
            return TableCollection._statementTypesSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "GetInfoMethodsTypesSprTable", {
        get: function () {
            if (TableCollection._getInfoMethodsTypesSprTable == null) {
                TableCollection._getInfoMethodsTypesSprTable = new GetInfoMethodsTypesSprTable();
            }
            return TableCollection._getInfoMethodsTypesSprTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "LegalEntityProviderTable", {
        get: function () {
            if (TableCollection._legalEntityProviderTable == null) {
                TableCollection._legalEntityProviderTable = new LegalEntityTable("LegalEntityProvider");
            }
            return TableCollection._legalEntityProviderTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "ForeignLegalEntityProviderTable", {
        get: function () {
            if (TableCollection._foreignLegalEntityProviderTable == null) {
                TableCollection._foreignLegalEntityProviderTable = new ForeignLegalEntityTable("ForeignLegalEntityProvider");
            }
            return TableCollection._foreignLegalEntityProviderTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "IndividualBusinessmanTable", {
        get: function () {
            if (TableCollection._individualBusinessmanTable == null) {
                TableCollection._individualBusinessmanTable = new PersonTable("IndividualBusinessmanProvider");
            }
            return TableCollection._individualBusinessmanTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "ForeignCitizenTable", {
        get: function () {
            if (TableCollection._foreignCitizenTable == null) {
                TableCollection._foreignCitizenTable = new ForeignPersonTable("ForeignCitizenProvider");
            }
            return TableCollection._foreignCitizenTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "BankTable", {
        get: function () {
            if (TableCollection._bankTable == null) {
                TableCollection._bankTable = new BankTable("Bank");
            }
            return TableCollection._bankTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "CustomerTable", {
        get: function () {
            if (TableCollection._customerTable == null) {
                TableCollection._customerTable = new CustomerTable("Customer");
            }
            return TableCollection._customerTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "LegalEntityProviderShortTable", {
        get: function () {
            if (TableCollection._legalEntityProviderShortTable == null) {
                TableCollection._legalEntityProviderShortTable = new LegalEntityShortTable("LegalEntityProviderShort");
            }
            return TableCollection._legalEntityProviderShortTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "ForeignLegalEntityProviderShortTable", {
        get: function () {
            if (TableCollection._foreignLegalEntityProviderShortTable == null) {
                TableCollection._foreignLegalEntityProviderShortTable = new ForeignLegalEntityShortTable("ForeignLegalEntityProviderShort");
            }
            return TableCollection._foreignLegalEntityProviderShortTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "IndividualBusinessmanShortTable", {
        get: function () {
            if (TableCollection._individualBusinessmanShortTable == null) {
                TableCollection._individualBusinessmanShortTable = new PersonShortTable("IndividualBusinessmanProviderShort");
            }
            return TableCollection._individualBusinessmanShortTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "ForeignCitizenShortTable", {
        get: function () {
            if (TableCollection._foreignCitizenShortTable == null) {
                TableCollection._foreignCitizenShortTable = new ForeignPersonShortTable("ForeignCitizenProviderShort");
            }
            return TableCollection._foreignCitizenShortTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "BankShortTable", {
        get: function () {
            if (TableCollection._bankShortTable == null) {
                TableCollection._bankShortTable = new BankShortTable("Bank", "Short");
            }
            return TableCollection._bankShortTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "CustomerShortTable", {
        get: function () {
            if (TableCollection._customerShortTable == null) {
                TableCollection._customerShortTable = new CustomerShortTable("Customer", "Short");
            }
            return TableCollection._customerShortTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "TofkTable", {
        get: function () {
            if (TableCollection._tofkTable == null) {
                TableCollection._tofkTable = new TofkTable("TOFKDetails");
            }
            return TableCollection._tofkTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "TofkMinfinTable", {
        get: function () {
            if (TableCollection._tofkMinfinTable == null) {
                TableCollection._tofkMinfinTable = new TofkTable("TOFKDetailsMinfin");
            }
            return TableCollection._tofkMinfinTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "DeclarerTable", {
        get: function () {
            if (TableCollection._declarerTable == null) {
                TableCollection._declarerTable = new DeclarerTable("DeclarerDetails", "Declarer");
            }
            return TableCollection._declarerTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableCollection, "SequenceTable", {
        get: function () {
            if (TableCollection._sequence == null) {
                TableCollection._sequence = new SequenceTable();
            }
            return TableCollection._sequence;
        },
        enumerable: true,
        configurable: true
    });

    Object.defineProperty(TableCollection, "PrintOptionsSprTable", {
        get: function () {
            if (TableCollection._PrintOptionsSprTable == null) {
                TableCollection._PrintOptionsSprTable = new PrintOptionsSprTable();
            }
            return TableCollection._PrintOptionsSprTable;
        },
        enumerable: true,
        configurable: true
    });
    
    return TableCollection;
}());
TableCollection._oksmSprTable = null;
TableCollection._okopfSprTable = null;
TableCollection._oktmoSprTable = null;
TableCollection._okvSprTable = null;
TableCollection._subjectsSprTable = null;
TableCollection._dataStatusesSprTable = null;
TableCollection._requestStatusesSprTable = null;
TableCollection._providerTypesSprTable = null;
TableCollection._planningStructureTypesSprTable = null;
TableCollection._roadNetworkTypesSprTable = null;
TableCollection._addressTypesSprTable = null;
TableCollection._documentTypesSprTable = null;
TableCollection._securityTypesSprTable = null;
TableCollection._statementTypesSprTable = null;
TableCollection._getInfoMethodsTypesSprTable = null;
TableCollection._legalEntityProviderTable = null;
TableCollection._foreignLegalEntityProviderTable = null;
TableCollection._individualBusinessmanTable = null;
TableCollection._foreignCitizenTable = null;
TableCollection._bankTable = null;
TableCollection._customerTable = null;
TableCollection._legalEntityProviderShortTable = null;
TableCollection._foreignLegalEntityProviderShortTable = null;
TableCollection._individualBusinessmanShortTable = null;
TableCollection._foreignCitizenShortTable = null;
TableCollection._bankShortTable = null;
TableCollection._customerShortTable = null;
TableCollection._tofkTable = null;
TableCollection._tofkMinfinTable = null;
TableCollection._declarerTable = null;
TableCollection._sequence = null;
TableCollection._PrintOptionsSprTable = null;
