﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var ObasTable = (function (_super) {
    __extends(ObasTable, _super);
    function ObasTable(id, keyFieldIds, isReadOnly) {
        if (keyFieldIds === void 0) { keyFieldIds = ["Key"]; }
        if (isReadOnly === void 0) { isReadOnly = false; }
        var _this = _super.call(this, id, isReadOnly) || this;
        _this._changeEvent = new TableChangeEvent();
        _this._keyFieldIds = keyFieldIds;
        _this._recordKey = new NumberObasTableField("Key", _this);
        return _this;
    }
    Object.defineProperty(ObasTable.prototype, "ChangeEvent", {
        get: function () {
            return this._changeEvent;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObasTable.prototype, "RecordKey", {
        get: function () {
            return this._recordKey;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObasTable.prototype, "KeyFieldIds", {
        get: function () {
            return this._keyFieldIds;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObasTable.prototype, "KeyFieldValues", {
        get: function () {
            var values = [];
            var length = this._keyFieldIds.length;
            for (var i = 0; i < length; i++) {
                values.push(this.GetFieldValue(this._keyFieldIds[i]));
            }
            return values;
        },
        enumerable: true,
        configurable: true
    });
    ObasTable.prototype.LocateByKeys = function (param) {
        return _super.prototype.Locate.call(this, this._keyFieldIds, param);
    };
    ObasTable.prototype.InitRecord = function (keyValues) {
        var length = this._keyFieldIds.length;
        this.AddRow();
        for (var i = 0; i < length; i++) {
            this.SetFieldValue(this._keyFieldIds[i], keyValues[i]);
        }
        this.PostRow();
    };
    ObasTable.prototype.SignNotif = function (handler) {
        this.ChangeEvent.Add(handler);
    };
    ObasTable.prototype.UnSignNotif = function (handler) {
        this.ChangeEvent.Remove(handler);
    };
    ObasTable.prototype.DoTableChange = function () {
        this.ChangeEvent.Do(this.RecordKey.Value);
    };
    return ObasTable;
}(Table));
var SprTable = (function (_super) {
    __extends(SprTable, _super);
    function SprTable(id, keyFields, codeFieldId, nameFieldId) {
        if (keyFields === void 0) { keyFields = ["Key"]; }
        if (codeFieldId === void 0) { codeFieldId = "Code"; }
        if (nameFieldId === void 0) { nameFieldId = "Name"; }
        var _this = _super.call(this, id, keyFields, true) || this;
        _this._code = new ObasTableField(codeFieldId, _this);
        _this._name = new ObasTableField(nameFieldId, _this);
        return _this;
    }
    Object.defineProperty(SprTable.prototype, "Code", {
        get: function () {
            return this._code;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SprTable.prototype, "Name", {
        get: function () {
            return this._name;
        },
        enumerable: true,
        configurable: true
    });
    SprTable.prototype.LookupKeyByCode = function (code) {
        return this.Lookup(this.Code.Id, code, this.RecordKey.Id);
    };
    SprTable.prototype.LookupKeyByName = function (name) {
        return this.Lookup(this.Name.Id, name, this.RecordKey.Id);
    };
    return SprTable;
}(ObasTable));
var ObasTableField = (function (_super) {
    __extends(ObasTableField, _super);
    function ObasTableField(id, table) {
        var _this = _super.call(this, EditorProObjectTypes.Field, id) || this;
        _this._caption = null;
        _this._exportNode = null;
        _this._table = table;
        return _this;
    }
    Object.defineProperty(ObasTableField.prototype, "Value", {
        get: function () {
            return this._table.GetFieldValue(this.Id);
        },
        set: function (value) {
            this._table.SetFieldValue(this.Id, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObasTableField.prototype, "Caption", {
        get: function () {
            if (this._caption == null) {
                this._caption = this._table.GetFieldAttribute(this.Id, TableFieldAttributes.Caption);
            }
            return this._caption;
        },
        enumerable: true,
        configurable: true
    });
    ObasTableField.prototype.GetAttrs = function () {
        var result = [];
        var fType = this._table.GetFieldAttribute(this.Id, TableFieldAttributes.Type);
        result.push({
            Name: "type",
            Value: fType,
            IsSystem: true
        });
        var isNull = this._table.GetFieldAttribute(this.Id, TableFieldAttributes.IsNull);
        result.push({
            Name: "isNull",
            Value: isNull,
            IsSystem: true
        });
        result.push({
            Name: "caption",
            Value: this.Caption,
            IsSystem: true
        });
        switch (fType.toLowerCase()) {
            case "string":
                result.push({
                    Name: "size",
                    Value: this._table.GetFieldAttribute(this.Id, TableFieldAttributes.Size),
                    IsSystem: true
                });
                result.push({
                    Name: "isStrictEqual",
                    Value: this._table.GetFieldAttribute(this.Id, TableFieldAttributes.IsStrictEqual),
                    IsSystem: true
                });
                break;
            case "float":
                result.push({
                    Name: "precision",
                    Value: this._table.GetFieldAttribute(this.Id, TableFieldAttributes.Precision),
                    IsSystem: true
                });
                break;
        }
        return result;
    };
    ObasTableField.prototype.LookupByKeys = function (param) {
        return this._table.Lookup(this._table.KeyFieldIds, param, this.Id);
    };
    ObasTableField.prototype.GenerateNode = function (nodeId) {
        var _this = this;
        var fType = this._table.GetFieldAttribute(this.Id, TableFieldAttributes.Type);
        var type;
        switch (fType.toLowerCase()) {
            case "string":
                type = new StringXmlElementType(this._table.GetFieldAttribute(this.Id, TableFieldAttributes.Size), this._table.GetFieldAttribute(this.Id, TableFieldAttributes.IsStrictEqual) || false);
                break;
            case "float":
                type = new FloatXmlElementType(this._table.GetFieldAttribute(this.Id, TableFieldAttributes.Precision));
                break;
            case "datetime":
                type = new DateTimeXmlElementType();
                break;
            case "boolean":
                type = new BooleanXmlElementType();
                break;
            default:
                type = new XmlElementType(fType);
        }
        this._exportNode = new SimpleNodeXmlElementInfo(nodeId || this.Id, type, function () { return _this.Value; }, this.Value, this._table.GetFieldAttribute(this.Id, TableFieldAttributes.IsRequiredDynamic), 1, this.Caption);
        this._exportNode.Value = this.Value;
        return this._exportNode;
    };
    ObasTableField.prototype.ExportTemplate = function (nodeId) {
        return ObasHelper.GenerateExportTemplate(this.GenerateNode(nodeId));
    };
    ObasTableField.prototype.toString = function (format) {
        return ObasHelper.ConvertToString(this.Value, format);
    };
    ObasTableField.prototype.DefferedSetValue = function (value) {
        this._table.SetFieldValue(this.Id, value, false);
    };
    Object.defineProperty(ObasTableField.prototype, "Table", {
        get: function () {
            return this._table;
        },
        enumerable: true,
        configurable: true
    });
    return ObasTableField;
}(BaseObject));
var NumberObasTableField = (function (_super) {
    __extends(NumberObasTableField, _super);
    function NumberObasTableField() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._precision = null;
        return _this;
    }
    Object.defineProperty(NumberObasTableField.prototype, "NValue", {
        get: function () {
            return this.Value || 0;
        },
        set: function (value) {
            this.Value = (value || 0);
        },
        enumerable: true,
        configurable: true
    });
    NumberObasTableField.prototype.DefferedSetValue = function (value) {
        _super.prototype.DefferedSetValue.call(this, value || 0);
    };
    Object.defineProperty(NumberObasTableField.prototype, "Precision", {
        get: function () {
            if (this._precision == null) {
                this._precision = parseInt(this.Table.GetFieldAttribute(this.Id, TableFieldAttributes.Precision), 10);
            }
            return this._precision;
        },
        enumerable: true,
        configurable: true
    });
    return NumberObasTableField;
}(ObasTableField));
var ObasSprTableField = (function (_super) {
    __extends(ObasSprTableField, _super);
    function ObasSprTableField(sprTable, table, newId) {
        var _this = _super.call(this, EditorProObjectTypes.None, newId ? newId : sprTable.Id) || this;
        _this._exportNode = null;
        _this._sprTable = sprTable;
        _this._nameField = _this.InitField(_this.Id + "_Name", table);
        _this._codeField = _this.InitField(_this.Id + "_Code", table);
        _this._keyField = new ObasForeignKeyTableField(sprTable, table, _this.Id);
        return _this;
    }
    ObasSprTableField.prototype.InitField = function (fieldId, table) {
        return (table.IsFieldExists(fieldId) ? new ObasTableField(fieldId, table) : null);
    };
    Object.defineProperty(ObasSprTableField.prototype, "Name", {
        get: function () {
            return this._nameField == null ? this._sprTable.Name.LookupByKeys(this._keyField.Value) : this._nameField.Value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObasSprTableField.prototype, "Code", {
        get: function () {
            return this._codeField == null ? this._sprTable.Code.LookupByKeys(this._keyField.Value) : this._codeField.Value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObasSprTableField.prototype, "ForeignKey", {
        get: function () {
            return this._keyField;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObasSprTableField.prototype, "NameFieldId", {
        get: function () {
            return this._nameField == null ? null : this._nameField.Id;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObasSprTableField.prototype, "CodeFieldId", {
        get: function () {
            return this._codeField == null ? null : this._codeField.Id;
        },
        enumerable: true,
        configurable: true
    });
    ObasSprTableField.prototype.ExportTemplate = function (nodeId) {
        return ObasHelper.GenerateExportTemplate(this.GenerateNode(nodeId));
    };
    ObasSprTableField.prototype.GenerateNode = function (nodeId) {
        var _this = this;
        var codeNode = (this._codeField != null ? this._codeField : this._sprTable.Code).GenerateNode("Code");
        var nameNode = (this._nameField != null ? this._nameField : this._sprTable.Name).GenerateNode("Name");
        this._exportNode = new ComplexNodeXmlElementInfo(nodeId || this.Id, this._sprTable.Caption);
        this._exportNode.AddChildNode(codeNode);
        this._exportNode.AddChildNode(nameNode);
        codeNode.SetupUpdateHandler(function () { return _this.Code; });
        codeNode.Value = this.Code;
        nameNode.SetupUpdateHandler(function () { return _this.Name; });
        nameNode.Value = this.Name;
        return this._exportNode;
    };
    Object.defineProperty(ObasSprTableField.prototype, "SourceTable", {
        get: function () {
            if (this._sprTable.LocateByKeys(this.ForeignKey.Value)) {
                return this._sprTable;
            }
            return null;
        },
        enumerable: true,
        configurable: true
    });
    return ObasSprTableField;
}(BaseObject));
var GenericForeignKeyTableField = (function (_super) {
    __extends(GenericForeignKeyTableField, _super);
    function GenericForeignKeyTableField(sourceTable, table, newId) {
        var _this = _super.call(this, (newId ? newId : sourceTable.Id) + "_ID", table) || this;
        _this._sourceTable = sourceTable;
        return _this;
    }
    GenericForeignKeyTableField.prototype.InitEventHandler = function (tableId, fieldId) {
        return this._sourceTable.RecordKey.Value;
    };
    Object.defineProperty(GenericForeignKeyTableField.prototype, "SourceTable", {
        get: function () {
            if (this._sourceTable.LocateByKeys(this.Value)) {
                return this._sourceTable;
            }
            return null;
        },
        enumerable: true,
        configurable: true
    });
    return GenericForeignKeyTableField;
}(NumberObasTableField));
var ObasForeignKeyTableField = (function (_super) {
    __extends(ObasForeignKeyTableField, _super);
    function ObasForeignKeyTableField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return ObasForeignKeyTableField;
}(GenericForeignKeyTableField));
var VersionElementForeignKeyTableField = (function (_super) {
    __extends(VersionElementForeignKeyTableField, _super);
    function VersionElementForeignKeyTableField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VersionElementForeignKeyTableField.prototype.UpdateReference = function (date) {
        var srcTable = this.SourceTable;
        if (srcTable) {
            var startDateId_1 = srcTable.StartDate.Id;
            var locateFields = srcTable.LocateFields.filter(function (value) {
                return value !== startDateId_1;
            });
            var locateKeys = [];
            for (var i = 0, len = locateFields.length; i < len; i++) {
                locateKeys.push(srcTable.GetFieldValue(locateFields[i]));
            }
            var newKey = srcTable.FindElementKey(date, locateKeys, locateFields);
            if (newKey) {
                this.Value = newKey;
            }
        }
    };
    return VersionElementForeignKeyTableField;
}(GenericForeignKeyTableField));
var ProviderKeyTableField = (function (_super) {
    __extends(ProviderKeyTableField, _super);
    function ProviderKeyTableField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return ProviderKeyTableField;
}(VersionElementForeignKeyTableField));
var TofkKeyTableField = (function (_super) {
    __extends(TofkKeyTableField, _super);
    function TofkKeyTableField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return TofkKeyTableField;
}(VersionElementForeignKeyTableField));
