﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var BaseXmlElementType = (function () {
    function BaseXmlElementType(_name, _type) {
        this._name = _name;
        this._type = _type;
    }
    Object.defineProperty(BaseXmlElementType.prototype, "Name", {
        get: function () {
            return this._name;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseXmlElementType.prototype, "Type", {
        get: function () {
            return this._type;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseXmlElementType.prototype, "ExportParams", {
        get: function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    BaseXmlElementType.prototype.ExportToXml = function (value, useCdata) {
        if (useCdata === void 0) { useCdata = true; }
        var result = ObasHelper.ConvertToString(value, this.ExportParams);
        if (useCdata && ObasHelper.AllowCData) {
            result = "<![CDATA[" + result + "]]>";
        }
        return result;
    };
    return BaseXmlElementType;
}());
var XmlElementType = (function (_super) {
    __extends(XmlElementType, _super);
    function XmlElementType(name) {
        return _super.call(this, name, NodeTypeTypes.Base) || this;
    }
    XmlElementType.prototype.ExportToXsd = function () {
        return "type=\"xs:" + this.Name + "\"";
    };
    return XmlElementType;
}(BaseXmlElementType));
var DateTimeXmlElementType = (function (_super) {
    __extends(DateTimeXmlElementType, _super);
    function DateTimeXmlElementType() {
        return _super.call(this, "dateTime") || this;
    }
    Object.defineProperty(DateTimeXmlElementType.prototype, "ExportParams", {
        get: function () {
            return DateFormat.Json;
        },
        enumerable: true,
        configurable: true
    });
    return DateTimeXmlElementType;
}(XmlElementType));
var BooleanXmlElementType = (function (_super) {
    __extends(BooleanXmlElementType, _super);
    function BooleanXmlElementType() {
        return _super.call(this, "boolean") || this;
    }
    Object.defineProperty(BooleanXmlElementType.prototype, "ExportParams", {
        get: function () {
            return DateFormat.Json;
        },
        enumerable: true,
        configurable: true
    });
    return BooleanXmlElementType;
}(XmlElementType));
var SimpleXmlElementType = (function (_super) {
    __extends(SimpleXmlElementType, _super);
    function SimpleXmlElementType(name) {
        return _super.call(this, name, NodeTypeTypes.Simple) || this;
    }
    SimpleXmlElementType.prototype.ExportToXsd = function () {
        var result = "<xs:simpleType>\n            <xs:restriction base=\"xs:" + this.Name + "\">\n              " + this.GetRestriction() + "\n            </xs:restriction>\n          </xs:simpleType>";
        return result;
    };
    return SimpleXmlElementType;
}(BaseXmlElementType));
var StringXmlElementType = (function (_super) {
    __extends(StringXmlElementType, _super);
    function StringXmlElementType(_size, _isStrict) {
        if (_isStrict === void 0) { _isStrict = false; }
        var _this = _super.call(this, "string") || this;
        _this._size = _size;
        _this._isStrict = _isStrict;
        return _this;
    }
    StringXmlElementType.prototype.GetRestriction = function () {
        var result = "<xs:maxLength value=\"" + this._size + "\"/>";
        if (this._isStrict) {
            result += "\n<xs:minLength value=\"" + this._size + "\"/>";
        }
        return result;
    };
    return StringXmlElementType;
}(SimpleXmlElementType));
var FloatXmlElementType = (function (_super) {
    __extends(FloatXmlElementType, _super);
    function FloatXmlElementType(_precision) {
        var _this = _super.call(this, "float") || this;
        _this._precision = _precision;
        return _this;
    }
    FloatXmlElementType.prototype.GetRestriction = function () {
        var result = "<xs:pattern value=\"^[0-9]{1,18}.[0-9]{" + this._precision + "}$\"/>";
        return result;
    };
    Object.defineProperty(FloatXmlElementType.prototype, "ExportParams", {
        get: function () {
            return this._precision;
        },
        enumerable: true,
        configurable: true
    });
    FloatXmlElementType.prototype.ExportToXml = function (value, useCdata) {
        return _super.prototype.ExportToXml.call(this, value, useCdata).replace(/,/g, ".");
    };
    return FloatXmlElementType;
}(SimpleXmlElementType));
var ComplexXmlElementType = (function (_super) {
    __extends(ComplexXmlElementType, _super);
    function ComplexXmlElementType() {
        return _super.call(this, "", NodeTypeTypes.Complex) || this;
    }
    Object.defineProperty(ComplexXmlElementType, "Instance", {
        get: function () {
            if (this._instance == null) {
                this._instance = new ComplexXmlElementType();
            }
            return this._instance;
        },
        enumerable: true,
        configurable: true
    });
    ComplexXmlElementType.prototype.ExportToXsd = function () {
        return "";
    };
    return ComplexXmlElementType;
}(BaseXmlElementType));
ComplexXmlElementType._instance = null;
var ChoiceXmlElementType = (function (_super) {
    __extends(ChoiceXmlElementType, _super);
    function ChoiceXmlElementType() {
        return _super.call(this, "", NodeTypeTypes.Choice) || this;
    }
    Object.defineProperty(ChoiceXmlElementType, "Instance", {
        get: function () {
            if (this._instance == null) {
                this._instance = new ChoiceXmlElementType();
            }
            return this._instance;
        },
        enumerable: true,
        configurable: true
    });
    ChoiceXmlElementType.prototype.ExportToXsd = function () {
        return "";
    };
    return ChoiceXmlElementType;
}(BaseXmlElementType));
ChoiceXmlElementType._instance = null;
var BaseXmlElementInfo = (function () {
    function BaseXmlElementInfo(_id, _name, _type, IsRequired, _description, Value) {
        if (IsRequired === void 0) { IsRequired = false; }
        this._id = _id;
        this._name = _name;
        this._type = _type;
        this.IsRequired = IsRequired;
        this._description = _description;
        this.Value = Value;
    }
    Object.defineProperty(BaseXmlElementInfo.prototype, "Type", {
        get: function () {
            return this._type;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseXmlElementInfo.prototype, "Name", {
        get: function () {
            return this._name;
        },
        enumerable: true,
        configurable: true
    });
    BaseXmlElementInfo.prototype.GetXsdAttrs = function () {
        var result = " name=\"" + this.Name + "\"";
        if (this.Type.Type === NodeTypeTypes.Base) {
            result += " " + this.Type.ExportToXsd();
        }
        return result;
    };
    BaseXmlElementInfo.prototype.GetAnnotation = function () {
        if (this._description) {
            return "<xs:annotation>\n          <xs:documentation xml:lang=\"ru-ru\">" + this._description + "</xs:documentation>\n        </xs:annotation>";
        }
        return "";
    };
    BaseXmlElementInfo.prototype.ExportToXsd = function () {
        var result = "<xs:" + this._id + this.GetXsdAttrs() + ">" + this.GetXsdBody() + "</xs:" + this._id + ">";
        return result;
    };
    BaseXmlElementInfo.prototype.ExportToXml = function () {
        return this.GetXmlBody();
    };
    return BaseXmlElementInfo;
}());
var AttributeXmlElementInfo = (function (_super) {
    __extends(AttributeXmlElementInfo, _super);
    function AttributeXmlElementInfo(name, type, _updateHandler, isRequired, description, value) {
        if (isRequired === void 0) { isRequired = false; }
        var _this = _super.call(this, "attribute", name, type, isRequired, description, value) || this;
        _this._updateHandler = _updateHandler;
        return _this;
    }
    AttributeXmlElementInfo.prototype.GetXsdAttrs = function () {
        var result = _super.prototype.GetXsdAttrs.call(this);
        result += " use=\"" + (this.IsRequired ? "required" : "optional") + "\"";
        return result;
    };
    AttributeXmlElementInfo.prototype.GetXsdBody = function () {
        var result = this.GetAnnotation();
        if (this.Type.Type === NodeTypeTypes.Simple) {
            result += this.Type.ExportToXsd();
        }
        return result;
    };
    AttributeXmlElementInfo.prototype.GetXmlBody = function () {
        if (this.Value != null) {
            return " " + this.Name + "=\"" + this.Type.ExportToXml(this.Value, false) + "\"";
        }
        else {
            return "";
        }
    };
    AttributeXmlElementInfo.prototype.UpdateData = function () {
        this.Value = this._updateHandler();
    };
    AttributeXmlElementInfo.prototype.SetupUpdateHandler = function (updateHandler) {
        this._updateHandler = updateHandler;
    };
    return AttributeXmlElementInfo;
}(BaseXmlElementInfo));
var NodeXmlElementInfo = (function (_super) {
    __extends(NodeXmlElementInfo, _super);
    function NodeXmlElementInfo(id, name, type, isRequired, MaxOccurs, description, value) {
        if (isRequired === void 0) { isRequired = false; }
        if (MaxOccurs === void 0) { MaxOccurs = 1; }
        var _this = _super.call(this, id, name, type, isRequired, description, value) || this;
        _this.MaxOccurs = MaxOccurs;
        return _this;
    }
    NodeXmlElementInfo.prototype.GetXsdAttrs = function () {
        var result = _super.prototype.GetXsdAttrs.call(this);
        if (!this.IsRequired) {
            result += " minOccurs=\"0\"";
        }
        if (this.MaxOccurs && this.MaxOccurs > -1) {
            result += " maxOccurs=\"" + (this.MaxOccurs === Number.MAX_VALUE ? "unbounded" : this.MaxOccurs) + "\"";
        }
        return result;
    };
    return NodeXmlElementInfo;
}(BaseXmlElementInfo));
var SimpleNodeXmlElementInfo = (function (_super) {
    __extends(SimpleNodeXmlElementInfo, _super);
    function SimpleNodeXmlElementInfo(name, type, _updateHandler, value, isRequired, maxOccurs, description) {
        if (isRequired === void 0) { isRequired = false; }
        if (maxOccurs === void 0) { maxOccurs = 1; }
        var _this = _super.call(this, "element", name, type, isRequired, maxOccurs, description, value) || this;
        _this._updateHandler = _updateHandler;
        return _this;
    }
    SimpleNodeXmlElementInfo.prototype.GetXsdBody = function () {
        var result = this.GetAnnotation();
        if (this.Type.Type === NodeTypeTypes.Simple) {
            result += this.Type.ExportToXsd();
        }
        return result;
    };
    SimpleNodeXmlElementInfo.prototype.GetXmlBody = function () {
        if (this.Value != null) {
            return "<" + this.Name + ">" + this.Type.ExportToXml(this.Value) + "</" + this.Name + ">";
        }
        else {
            return "";
        }
    };
    SimpleNodeXmlElementInfo.prototype.UpdateData = function () {
        this.Value = this._updateHandler();
    };
    SimpleNodeXmlElementInfo.prototype.SetupUpdateHandler = function (updateHandler) {
        this._updateHandler = updateHandler;
    };
    return SimpleNodeXmlElementInfo;
}(NodeXmlElementInfo));
var NodeWithChildsXmlElementInfo = (function (_super) {
    __extends(NodeWithChildsXmlElementInfo, _super);
    function NodeWithChildsXmlElementInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._childsNodes = [];
        return _this;
    }
    Object.defineProperty(NodeWithChildsXmlElementInfo.prototype, "Childs", {
        get: function () {
            return this._childsNodes;
        },
        enumerable: true,
        configurable: true
    });
    NodeWithChildsXmlElementInfo.prototype.AddChildNode = function (nodeParam) {
        if (nodeParam instanceof NodeXmlElementInfo) {
            this._childsNodes.push(nodeParam);
        }
        else {
            this._childsNodes = nodeParam;
        }
    };
    NodeWithChildsXmlElementInfo.prototype.UpdateData = function () {
        for (var i = 0, len = this.Childs.length; i < len; i++) {
            this.Childs[i].UpdateData();
        }
    };
    return NodeWithChildsXmlElementInfo;
}(NodeXmlElementInfo));
var ChoiceNodeXmlElementInfo = (function (_super) {
    __extends(ChoiceNodeXmlElementInfo, _super);
    function ChoiceNodeXmlElementInfo() {
        var _this = _super.call(this, "choice", "choice", ChoiceXmlElementType.Instance, false, 0, null, null) || this;
        _this._exportIndex = -1;
        return _this;
    }
    ChoiceNodeXmlElementInfo.prototype.GetXsdAttrs = function () {
        return "";
    };
    Object.defineProperty(ChoiceNodeXmlElementInfo.prototype, "ExportIndex", {
        get: function () {
            return this._exportIndex;
        },
        set: function (value) {
            this._exportIndex = value;
        },
        enumerable: true,
        configurable: true
    });
    ChoiceNodeXmlElementInfo.prototype.GetXsdBody = function () {
        var result = "";
        for (var i = 0, len = this.Childs.length; i < len; i++) {
            result += this.Childs[i].ExportToXsd();
        }
        return result;
    };
    ChoiceNodeXmlElementInfo.prototype.GetXmlBody = function () {
        var node;
        if (this.ExportIndex > -1 && this.ExportIndex < this.Childs.length) {
            node = this.Childs[this.ExportIndex];
        }
        return node ? node.ExportToXml() : "";
    };
    return ChoiceNodeXmlElementInfo;
}(NodeWithChildsXmlElementInfo));
var ComplexNodeXmlElementInfo = (function (_super) {
    __extends(ComplexNodeXmlElementInfo, _super);
    function ComplexNodeXmlElementInfo(name, description, isRequired, maxOccurs) {
        if (isRequired === void 0) { isRequired = false; }
        if (maxOccurs === void 0) { maxOccurs = 1; }
        var _this = _super.call(this, "element", name, ComplexXmlElementType.Instance, isRequired, maxOccurs, description, null) || this;
        _this._attrsNodes = [];
        return _this;
    }
    ComplexNodeXmlElementInfo.prototype.GetXsdBody = function () {
        var result = "<xs:complexType>";
        result += this.GetAnnotation();
        result += "<xs:sequence>";
        for (var i = 0, len = this.Childs.length; i < len; i++) {
            result += this.Childs[i].ExportToXsd();
        }
        result += "</xs:sequence>";
        for (var i = 0, len = this._attrsNodes.length; i < len; i++) {
            result += this._attrsNodes[i].ExportToXsd();
        }
        result += "</xs:complexType>";
        return result;
    };
    ComplexNodeXmlElementInfo.prototype.GetXmlBody = function () {
        var body = "";
        for (var i = 0, len = this.Childs.length; i < len; i++) {
            body += this.Childs[i].ExportToXml();
        }
        if (body.length > 0) {
            return "<" + this.Name + this.GetXmlAttrs() + ">" + body + "</" + this.Name + ">";
        }
        else {
            return "";
        }
    };
    ComplexNodeXmlElementInfo.prototype.AddAttrNode = function (attr) {
        this._attrsNodes.push(attr);
    };
    ComplexNodeXmlElementInfo.prototype.GetXmlAttrs = function () {
        var result = "";
        for (var i = 0, len = this._attrsNodes.length; i < len; i++) {
            result += " " + this._attrsNodes[i].ExportToXml();
        }
        return result;
    };
    return ComplexNodeXmlElementInfo;
}(NodeWithChildsXmlElementInfo));
var UnboundNodeXmlElementInfo = (function () {
    function UnboundNodeXmlElementInfo(_xsdNode, _updateHandler) {
        this._xsdNode = _xsdNode;
        this._updateHandler = _updateHandler;
        this._dataNodes = null;
        this._name = _xsdNode.Name;
    }
    UnboundNodeXmlElementInfo.prototype.UpdateData = function () {
        this._dataNodes = this._updateHandler();
    };
    UnboundNodeXmlElementInfo.prototype.ExportToXsd = function () {
        return this._xsdNode.ExportToXsd();
    };
    UnboundNodeXmlElementInfo.prototype.ExportToXml = function () {
        this.UpdateData();
        var result = "";
        for (var i = 0, len = this._dataNodes.length; i < len; i++) {
            result += this._dataNodes[i].ExportToXml();
        }
        return result;
    };
    Object.defineProperty(UnboundNodeXmlElementInfo.prototype, "Name", {
        get: function () {
            return this._name;
        },
        enumerable: true,
        configurable: true
    });
    ;
    return UnboundNodeXmlElementInfo;
}());
